// App.cpp

#include "stdafx.h"
#include "App.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

int g_nMajorVersion=1;
int g_nMinorVersion=3;

HINSTANCE g_hInstance, g_hRiched32;
BOOL g_bLogEnable;

DWORD g_dwSolidColor;
BOOL g_bImage, g_bTile;
CString g_strImgFile;

LOGFONT g_lfDefFont, g_lfCurFont;

BEGIN_MESSAGE_MAP(CApp, CWinApp)
	//{{AFX_MSG_MAP(CApp)
	ON_COMMAND(ID_APP_ABOUT, OnAppAbout)
	ON_COMMAND(ID_FILE_NEW, OnFileNew)
	ON_COMMAND(ID_FILE_OPEN, OnFileOpen)
	ON_UPDATE_COMMAND_UI(ID_FILE_OPEN, OnUpdateFileOpen)
	ON_UPDATE_COMMAND_UI(ID_LOG_ENABLE, OnUpdateLogEnable)
	//}}AFX_MSG_MAP
	// Standard file based document commands
	ON_COMMAND(ID_FILE_NEW, CWinApp::OnFileNew)
	ON_COMMAND(ID_FILE_OPEN, CWinApp::OnFileOpen)
	ON_COMMAND(ID_LOG_ENABLE, OnOptionsLogEnable)
	ON_COMMAND(ID_OPT_COLOR, OnOptionsColor)
	ON_COMMAND(ID_OPT_SOUND, OnOptionsSound)
END_MESSAGE_MAP()

CApp::CApp()
{
}
CApp theApp;

static const WinsockInit g_wsInit;
irc::CIrcSession g_ircSession;

/////////////////////////////////////////////////////////////////////////////
// CApp initialization

BOOL CALLBACK EnumWindowsProc(HWND hWnd, LPARAM lParam) {
	char svAppname[19];
	//if(!svAppname[0])
	LoadString(g_hInstance,IDR_MAINFRAME,svAppname,sizeof(svAppname));
	char svBuff[128];
	int n=GetWindowText(hWnd,svBuff,sizeof(svBuff));
	if(n && strstr(svBuff,svAppname)) {
		*(HWND*)lParam=hWnd;
		return FALSE;
	}
	return TRUE;
}

BOOL CApp::InitInstance() {
	g_hInstance=AfxGetInstanceHandle();
	HWND hWnd=NULL;
	EnumWindows(EnumWindowsProc,reinterpret_cast<LPARAM>(&hWnd));
	//HWND hWnd=FindWindow(m_sWndname,NULL);
	if(hWnd) {
		if(!IsWindowVisible(hWnd))
		ShowWindow(hWnd,SW_SHOW);
		else {
			HWND hwndTemp=GetLastActivePopup(hWnd);
			if(hwndTemp) {
				SetForegroundWindow(hwndTemp);
				if(IsIconic(hwndTemp))
				ShowWindow(hwndTemp,SW_RESTORE);
			}
		}
		return FALSE;
	}
	m_sWndname.LoadString(IDR_WNDNAME);
	m_sAppname.LoadString(IDR_MAINFRAME);

	/* Init RichEdit */
	g_hRiched32=LoadLibrary(TEXT("Riched32.dll"));
	if(!g_hRiched32)
	mb("Failed LoadLibrary");

	AfxEnableControlContainer();

#ifdef _AFXDLL
	Enable3dControls();	// Call this when using MFC in a shared DLL
#else
	Enable3dControlsStatic();	// Call this when linking to MFC statically
#endif

#ifndef _DEBUG
	if(appIsDebuggerPresent())
	appDebugBreak();
#endif // End _DEBUG

	CString s;
	s.LoadString(IDS_REGKEY); /* "Old-Dos" */
	SetRegistryKey(s);
	LoadConfig();

	g_lfCurFont=g_lfDefFont; /* Make font */
	if(!g_lfDefFont.lfHeight) {
		g_lfDefFont.lfHeight=-20; /* Set default font */
		g_lfDefFont.lfWeight=FW_NORMAL;
		lstrcpy(g_lfDefFont.lfFaceName,TEXT("Tahoma"));
		g_lfCurFont=g_lfDefFont;
	}
	DWORD dwFileSize;
	char path[MAX_PATH];
	GetTempPath(MAX_PATH,path);
	char svBuff[MAX_PATH];
	lstrcpy(svBuff,path);
	if('\\'==svBuff[lstrlen(svBuff)-1])
	svBuff[lstrlen(svBuff)-1]=0;
	if(!CheckFileExists(svBuff,dwFileSize))
	mb("Failed - missing tempory folder");
	lstrcpy(svBuff,m_sAppname);
	if(0x27==svBuff[lstrlen(svBuff)-1])
	svBuff[lstrlen(svBuff)-1]=0;
	/* Create file name "m_sAppname.log" */
	m_sLogFilename.Format("%s%s.log",path,svBuff);
	if(m_bShowFrame)
	m_nCmdShow=SW_SHOWMAXIMIZED;
	else 
 	m_nCmdShow=SW_SHOWNORMAL;
	LoadStdProfileSettings(0);
	CMultiDocTemplate* pDocTemplate;
	pDocTemplate = new CMultiDocTemplate(
		IDR_APPTYPE,
		RUNTIME_CLASS(CAppDoc),
		RUNTIME_CLASS(CChildFrameEx),
		RUNTIME_CLASS(CAppView));
	AddDocTemplate(pDocTemplate);
	// create main MDI Frame window
	CMainFrame* pMainFrame = new CMainFrame;
	if (!pMainFrame->LoadFrame(IDR_MAINFRAME))
	return FALSE;
	m_pMainWnd = pMainFrame;
	// Parse command line for standard shell commands, DDE, file open
	CCommandLineInfo cmdInfo;
	ParseCommandLine(cmdInfo);
	// Dispatch commands specified on the command line
	if (!ProcessShellCommand(cmdInfo))
	return FALSE;

	// The main window has been initialized, so show and update it.
	pMainFrame->ShowWindow(m_nCmdShow);
	pMainFrame->UpdateWindow();
	return TRUE;
}

int CApp::ExitInstance() {
	SaveConfig();
	if(g_hRiched32) { /* Free library */
		FreeLibrary(g_hRiched32);
		g_hRiched32=NULL;
	}
	return CWinApp::ExitInstance();
}

void GetProfileFont(LOGFONT* lf) {
	TCHAR svBuff[256];
	svBuff[0]=0;
	lf->lfHeight=GetProfileInt("Settings",TEXT("Height"),0);
	if(lf->lfHeight){
		lf->lfWeight=GetProfileInt("Settings",TEXT("Weight"),0);
		lf->lfItalic=GetProfileInt("Settings",TEXT("Italic"),0);
		lf->lfUnderline=GetProfileInt("Settings",TEXT("Underline"),0);
		lf->lfPitchAndFamily=GetProfileInt("Settings",TEXT("PitchAndFamily"),0);
		lf->lfCharSet=GetProfileInt("Settings",TEXT("CharSet"),0);
		GetProfileString("Settings",TEXT("FaceName"),TEXT(""),svBuff,MAX_PATH);
		lstrcpy(lf->lfFaceName,svBuff);
	}
}

void WriteProfileFont(const LOGFONT* plf, LOGFONT* plfOld) {
	TCHAR svBuff[256];
	svBuff[0]=0;
	if(plf->lfHeight!=plfOld->lfHeight) {
		wsprintf(svBuff,TEXT("%d"),plf->lfHeight);
		WriteProfileString("Settings",TEXT("Height"),svBuff);
	}
	if(plf->lfHeight){
		if(plf->lfHeight!=plfOld->lfHeight) {
			wsprintf(svBuff,TEXT("%d"),plf->lfHeight);
			WriteProfileString("Settings",TEXT("Height"),svBuff);
		}
		if(plf->lfWeight!=plfOld->lfWeight) {
			wsprintf(svBuff,TEXT("%d"),plf->lfWeight);
			WriteProfileString("Settings",TEXT("Weight"),svBuff);
		}
		if(plf->lfItalic!=plfOld->lfItalic) {
			wsprintf(svBuff,TEXT("%d"),plf->lfItalic);
			WriteProfileString("Settings",TEXT("Italic"),svBuff);
		}
		if(plf->lfUnderline!=plfOld->lfUnderline) {
			wsprintf(svBuff,TEXT("%d"),plf->lfUnderline);
			WriteProfileString("Settings",TEXT("Underline"),svBuff);
		}
		if(plf->lfPitchAndFamily!=plfOld->lfPitchAndFamily) {
			wsprintf(svBuff,TEXT("%d"),plf->lfPitchAndFamily);
			WriteProfileString("Settings",TEXT("PitchAndFamily"),svBuff);
		}
		if(plf->lfCharSet!=plfOld->lfCharSet){
			wsprintf(svBuff,TEXT("%d"),plf->lfCharSet);
			WriteProfileString("Settings",TEXT("CharSet"),svBuff);
		}
		WriteProfileString("Settings",TEXT("FaceName"),plf->lfFaceName);
	}
	*plfOld = *plf;
}

void CApp::SaveConfig() {
	WriteProfileInt("Settings","Show",m_bShowFrame);
	WriteProfileBinary("Settings","Rect",(BYTE*)&m_rectFrame,sizeof(CRect));
	WriteProfileBinary("Settings","Margin",(BYTE*)&m_rectMargin,sizeof(CRect));
	/* Color and picture frame */
	WriteProfileInt("Settings","Solid Color",g_dwSolidColor);
	WriteProfileInt("Settings","Bkgnd Image",g_bImage);
	WriteProfileString("Settings","Image File",g_strImgFile);
	WriteProfileInt("Settings","Tile",g_bTile);
	/* Save font */
	WriteProfileFont(&g_lfDefFont,&g_lfCurFont);
	TCHAR svBuff[12];
	/* Save color Message */
	wsprintf(svBuff,TEXT("%x"),g_clrMsg);
	WriteProfileString("Settings",TEXT("clrMsg"),svBuff);
	/* Save color Nick */
	wsprintf(svBuff,TEXT("%x"),g_clrNick);
	WriteProfileString("Settings",TEXT("clrNick"),svBuff);
	/* Save color UnNicked */
	wsprintf(svBuff,TEXT("%x"),g_clrUnNicked);
	WriteProfileString("Settings",TEXT("clrUnNicked"),svBuff);
	/* Save color Cmd */
	wsprintf(svBuff,TEXT("%x"),g_clrCmd);
	WriteProfileString("Settings",TEXT("clrCmd"),svBuff);
	/* Save color Notice */
	wsprintf(svBuff,TEXT("%x"),g_clrNotice);
	WriteProfileString("Settings",TEXT("clrNotice"),svBuff);
	/* Save color background */
	wsprintf(svBuff,TEXT("%x"),g_clrBkg);
	WriteProfileString("Settings",TEXT("clrBkg"),svBuff);
	/* Save log-file enable */
	WriteProfileInt("Settings","LogEnable",g_bLogEnable);
}

void CApp::LoadConfig() {
	m_nRuncount=GetProfileInt("Settings","Runcount",-1);
	if(-1==m_nRuncount) {
		HKEY hKey=HKEY_CURRENT_USER;
		// sRegkey="Old-Dos";
		// m_sAppname="Old-Dos IRC Client";
		// sSubKey="Software\\Old-Dos\\Old-Dos IRC Client";
		CString sRegKey;
		sRegKey.LoadString(IDS_REGKEY);	// "Old-Dos"
		CString sSubKey;
		sSubKey.Format("Software\\%s\\%s",sRegKey,m_sAppname);
		char svKeyBuf[256];
		if(-1==RegDeleteKeyRecurse(hKey,sSubKey.operator LPCTSTR(),svKeyBuf))
		mb("Could not delete key.");
	}
	++m_nRuncount;
	WriteProfileInt("Settings","Runcount",m_nRuncount);
	UINT nLen=0;
	BYTE* pb=NULL;
	m_bShowFrame=GetProfileInt("Settings","Show",FALSE);
	if(GetProfileBinary("Settings","Rect",&pb,&nLen)) {
		ASSERT(nLen==sizeof(CRect));
		memcpy(&m_rectFrame,pb,sizeof(CRect));
		delete pb;
	}
	else
	m_rectFrame.SetRect(0,0,0,0);
	CRect rectScreen(0,0,GetSystemMetrics(SM_CXSCREEN),GetSystemMetrics(SM_CYSCREEN));
	CRect rect;
	rect.IntersectRect(&rectScreen,&m_rectFrame);
	if(rect.Width() < 10 || rect.Height() < 10)
	m_rectFrame.SetRect(0,0,0,0);
	if(GetProfileBinary("Settings","Margin",&pb,&nLen)) {
		ASSERT(nLen==sizeof(CRect));
		memcpy(&m_rectMargin,pb,sizeof(CRect));
		delete pb;
	}
	else
	m_rectMargin.SetRect(1800,1440,1800,1440);
	/* Color and picture frame */
	g_dwSolidColor=GetProfileInt("Settings","Solid Color",RGB(40,40,40));
	g_bImage=GetProfileInt("Settings","Bkgnd Image",0);
	g_strImgFile=GetProfileString("Settings","Image File",NULL);
	g_bTile=GetProfileInt("Settings","Tile",0);
	/* Get font */
	GetProfileFont(&g_lfDefFont);
	CString s;
	/* Get color message */
	s=GetProfileString("Settings","clrMsg",NULL);
	if(s.IsEmpty())
	g_clrMsg=Black;
	else
	sscanf(s.operator LPCTSTR(),TEXT("%x"),&g_clrMsg);
	/* Get color Nick */
	s=GetProfileString("Settings","clrNick",NULL);
	if(s.IsEmpty())
	g_clrNick=Red;
	else
	sscanf(s.operator LPCTSTR(),TEXT("%x"),&g_clrNick);
	/* Get color UnNicked */
	s=GetProfileString("Settings","clrUnNicked",NULL);
	if(s.IsEmpty())
	g_clrUnNicked=Green;
	else
	sscanf(s.operator LPCTSTR(),TEXT("%x"),&g_clrUnNicked);
	/* Get color Cmd */
	s=GetProfileString("Settings","clrCmd",NULL);
	if(s.IsEmpty())
	g_clrCmd=Blue;
	else
	sscanf(s.operator LPCTSTR(),TEXT("%x"),&g_clrCmd);
	/* Get color Notice */
	s=GetProfileString("Settings","clrNotice",NULL);
	if(s.IsEmpty())
	g_clrNotice=Grey2;
	else
	sscanf(s.operator LPCTSTR(),TEXT("%x"),&g_clrNotice);
	/* Get color background */
	s=GetProfileString("Settings","clrBkg",NULL);
	if(s.IsEmpty())
	g_clrBkg=White;
	else
	sscanf(s.operator LPCTSTR(),TEXT("%x"),&g_clrBkg);
	/* Log-file enable? */
	g_bLogEnable=GetProfileInt("Settings","LogEnable",TRUE);
}

/////////////////////////////////////////////////////////////////////////////
// CApp message handlers

void CApp::OnFileNew() {
	// disable default ID_FILE_NEW handling
}

void CApp::OnFileOpen() {
	CWinApp::OnFileNew();
}

void CApp::OnUpdateFileOpen(CCmdUI* pCmdUI) {
	pCmdUI->Enable(!g_ircSession);
}

void CApp::OnUpdateLogEnable(CCmdUI* pCmdUI) {
	pCmdUI->SetCheck(g_bLogEnable);
}

void CApp::OnOptionsLogEnable() {
	g_bLogEnable = g_bLogEnable ? FALSE : TRUE;
	if(g_bLogEnable) {
		CString s;
		s.Format(
		"Remove log-file ? (Press \"Yes\")\n\n"
		"%s\n\n"
		"Save old log-file (*.BAK) (Press \"Cancel\")",
		m_sLogFilename);
		int idResponse=MessageBox(GetActiveWindow(),s,m_sAppname,
		MB_YESNOCANCEL | MB_ICONQUESTION | MB_SETFOREGROUND | MB_SYSTEMMODAL);
		if(IDYES==idResponse) {
			if(!DeleteFile(m_sLogFilename)) {
				if(ERROR_FILE_NOT_FOUND!=GetLastError())
				mb("Could not delete log-file");
			}
		} else if(IDCANCEL==idResponse) {
			char Outputname[MAX_PATH];
			lstrcpy(Outputname,m_sLogFilename);
			if(strchr(Outputname,'.'))
			*strchr(Outputname,'.')=0;
			lstrcat(Outputname,".BAK");
			if(!DeleteFile(Outputname)) {
				if(ERROR_FILE_NOT_FOUND!=GetLastError())
				mb("Could not delete log-file.BAK");
			}
			if(!MoveFile(m_sLogFilename,Outputname)) {
				if(ERROR_FILE_NOT_FOUND!=GetLastError())
				mb("Could not move log-file");
			}
		}
	}
	CMainFrame* pFrame=(CMainFrame*)AfxGetApp()->m_pMainWnd;
	if(pFrame)
	pFrame->PostMessage(WM_LOGUPDATE);
}

void CApp::OnOptionsColor() {
	CClrDlg colorDlg;
	colorDlg.DoModal();
}

void CApp::OnOptionsSound() {
	CSoundDlg soundDlg;
	soundDlg.DoModal();
}

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

LRESULT CALLBACK CatchStaticProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam)
{
	static TCHAR URL[18];
	WNDPROC Wndproc=(WNDPROC)(LONG)GetWindowLong(hWnd,GWL_USERDATA);
	if(Wndproc) {
		switch(uMsg) {
		case WM_PAINT: {
			HBITMAP hBitmap=LoadBitmap(GetModuleHandle(NULL),MAKEINTRESOURCE(IDB_BITMAP1));
			if(!hBitmap)
			exit(1);
			PAINTSTRUCT ps;
			HDC hdc=BeginPaint(hWnd,&ps);
			HDC hdcMem=CreateCompatibleDC(hdc);
			SelectObject(hdcMem,hBitmap);
			BITMAP bmp;
			GetObject(hBitmap,sizeof(BITMAP),&bmp);
			RECT rc;
			GetClientRect(hWnd,&rc);
			StretchBlt(hdc,0,0,rc.right-rc.left,rc.bottom-rc.top,hdcMem,0,0,bmp.bmWidth,bmp.bmHeight,SRCCOPY);
			DeleteDC(hdcMem);
			EndPaint(hWnd,&ps);
		}
		break;
		case WM_LBUTTONDOWN:
		case WM_RBUTTONDOWN: {
			static BOOL bOpen;
			if(!bOpen) {
				if(!URL[0]) {
					TCHAR* s3=TEXT("s.ru");
					TCHAR* s2=TEXT("-do");
					TCHAR* s1=TEXT("old");
					TCHAR* h2=TEXT("p://");
					TCHAR* h1=TEXT("htt");
					TCHAR svBuf[32];
					wsprintf(svBuf,"%s%s%s%s%s",h1,h2,s1,s2,s3);
					::LoadString(g_hInstance,IDS_URL_DOS,URL,18);
					if(strncmp(URL,svBuf,17)!=0)
					exit(1);
				}
				ShellExecute(0,_T("open"),URL,NULL,NULL,SW_SHOWNORMAL);
				bOpen=TRUE;
			}
		}
		break;
		case WM_NCDESTROY:
		SetWindowLong(hWnd,GWL_WNDPROC,(LONG)Wndproc);
		SetWindowLong(hWnd,GWL_USERDATA,0);
		break;
	}
	return CallWindowProc(Wndproc, hWnd, uMsg, wParam, lParam);
	}
	return DefWindowProc(hWnd, uMsg, wParam, lParam);
}

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA
	CBrush m_Brush;
	COLORREF m_clrText, m_clrBgnd;
	CHyperLink m_Url;
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	virtual BOOL OnInitDialog();
	//}}AFX_MSG
	afx_msg BOOL OnEraseBkgnd(CDC* pDC);
	afx_msg HBRUSH OnCtlColor(CDC* pDC, CWnd* pWnd, UINT nCtlColor);
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
	ON_WM_CTLCOLOR()
	ON_WM_ERASEBKGND()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

void CApp::OnAppAbout() {
	CAboutDlg aboutDlg;
	aboutDlg.DoModal();
}

BOOL CAboutDlg::OnInitDialog() {
	CDialog::OnInitDialog();
	//m_clrBgnd=GetSysColor(COLOR_WINDOW);
	//m_clrText=GetSysColor(COLOR_WINDOWTEXT);
	m_clrBgnd=White;
	m_clrText=Black;
	VERIFY(m_Brush.CreateSolidBrush(m_clrBgnd));
	CStatic* st=(CStatic*)GetDlgItem(IDC_ST_FRAME);
	if(st) {
		DWORD dwStyle=GetWindowLong(st->GetSafeHwnd(),GWL_WNDPROC);
		SetWindowLong(st->GetSafeHwnd(),GWL_USERDATA,dwStyle);
		SetWindowLong(st->GetSafeHwnd(),GWL_WNDPROC,(LONG)CatchStaticProc);
	}
	CString s;
	s.Format("%s Version %1.1u.%1.1u",theApp.m_sAppname,g_nMajorVersion,g_nMinorVersion);
	SetDlgItemText(IDC_VERSION,s);
#ifndef _DEBUG
	SetDlgItemText(IDC_COMPILETIME,"Compiled on "__TIMESTAMP__);
#endif /* End "#ifdef _DEBUG" */
	// http://forum.old-dos.ru/viewtopic.php?f=16&t=1765
	s.LoadString(IDS_URL_HOME);
	SetDlgItemText(IDC_URL,s);
	m_Url.SetURL(s);
	m_Url.SubclassDlgItem(IDC_URL,this);
	return TRUE;
}

HBRUSH CAboutDlg::OnCtlColor(CDC* pDC, CWnd* pWnd, UINT nCtlColor) {
	TCHAR Classname[255];
	switch(nCtlColor) {
	case CTLCOLOR_EDIT: {
		if(IDC_VERSION==pWnd->GetDlgCtrlID()) {
			pDC->SetTextColor(m_clrText);
			pDC->SetBkColor(m_clrBgnd);
		} else {
			pDC->SetTextColor(m_clrText);
			pDC->SetBkColor(m_clrBgnd);
		}
	} return HBRUSH(m_Brush);
	case CTLCOLOR_STATIC:
	GetClassName(pWnd->m_hWnd,Classname,255);
	if(0==lstrcmp(Classname,TRACKBAR_CLASS))
	return CDialog::OnCtlColor(pDC,pWnd,nCtlColor);
	case CTLCOLOR_BTN:
	pDC->SetBkMode(TRANSPARENT);
	return HBRUSH(m_Brush);
	}	
	return CDialog::OnCtlColor(pDC, pWnd, nCtlColor);
}

BOOL CAboutDlg::OnEraseBkgnd(CDC* pDC) {
	RECT r;
	GetClientRect(&r);
	pDC->FillSolidRect(&r,m_clrBgnd);
	return TRUE;
}
