// App.h

#pragma once

#ifndef __AFXWIN_H__
	#error include 'stdafx.h' before including this file for PCH
#endif

#define	TIMER_MAIN				1
#define	TIMER_MAIN_DELAY		1000

#define	IRCM_NOTIFY				(WM_USER+1000)
#define	WM_RETURNPRESSED		(WM_USER+1001)
#define	RICHEDIT_WM_RBUTTONDOWN	(WM_USER+1002)
#define WM_LOGUPDATE			(WM_USER+1003)
#define IDM_RECALC_SIZE			(WM_USER+1004)

#define	MAX_LOADSTRING			100

#include "resource.h"       // main symbols
#include "ConDlg.h"
#include "ChannelDlg.h"
#include "SoundDlg.h"
#include "ClrDlg.h"
#include "HyperLink.h"
#include "Irc.h"
#include "EditEx.h"

#include "ChildFrmEx.h"
#include "AppDoc.h"
#include "AppView.h"
#include "MainFrm.h"
#include "Splash.h"

extern irc::CIrcSession g_ircSession;

class CApp : public CWinApp
{
public:
	CString m_sWndname;
	CString m_sAppname;
	CString m_sLogFilename;

	int m_nRuncount;

	CRect m_rectFrame;
	CRect m_rectMargin;
	BOOL m_bShowFrame;

	CApp();
	void LoadConfig();
	void SaveConfig();
	//CAppView* GetActiveView();

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CApp)
	public:
	virtual BOOL InitInstance();
	virtual int ExitInstance();
	//}}AFX_VIRTUAL

// Implementation
	//{{AFX_MSG(CApp)
	afx_msg void OnAppAbout();
	afx_msg void OnFileNew();
	afx_msg void OnFileOpen();
	afx_msg void OnUpdateFileOpen(CCmdUI* pCmdUI);
	afx_msg void OnUpdateLogEnable(CCmdUI* pCmdUI);
	afx_msg void OnOptionsLogEnable();
	afx_msg void OnOptionsColor();
	afx_msg void OnOptionsSound();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

extern CApp theApp;

extern HINSTANCE g_hInstance;
extern BOOL g_bLogEnable;

extern DWORD g_dwSolidColor;
extern BOOL g_bImage, g_bTile;
extern CString g_strImgFile;

extern LOGFONT g_lfDefFont, g_lfCurFont;

extern DWORD Aqua, Black, Blue, Green, Red;
extern DWORD Brown, Yellow, White, Grey, Grey2;

extern COLORREF g_clrMsg, g_clrNick, g_clrUnNicked;
extern COLORREF g_clrCmd, g_clrNotice, g_clrBkg;

void mb(char* Str);
void* __cdecl appMalloc(size_t size);
void __cdecl appFree(void* ptr);
char* appBaseDir();
BOOL CheckFileExists(char* fname, DWORD& dwFileSize);
char* BreakString(char* Lines, char* Tok);
char* LogDateTime();
void log(char* fname, char* s,
	BOOL bRewrite=FALSE,
	DWORD dwNumberOfBytesToWrite=0);

char* GetDataFromClipBoard(void);

#ifndef _DEBUG
void appDebugBreak();
BOOL appIsDebuggerPresent();
#endif // End _DEBUG

int RegDeleteKeyRecurse(HKEY hKey, LPCTSTR lpSubKey, char* svKeyBuf);
char* ConvertByte(float Bytes);

LRESULT CALLBACK RichEdit_WndProc(HWND,UINT,WPARAM,LPARAM);
LRESULT CALLBACK MDI_WndProc(HWND,UINT,WPARAM,LPARAM);

void appSetFont(HWND hWnd, LOGFONT* plfOld);
COLORREF appChooseColor(HWND hWnd, COLORREF clrCurrent);
HBRUSH appCreateColor(COLORREF clrCurrent);
void Beep(char* svFilename);
