// AppDoc.cpp

#include "stdafx.h"
#include "App.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

DECLARE_IRC_MAP(CAppDoc, CIrcDefaultMonitor)

IMPLEMENT_DYNCREATE(CAppDoc, CDocument)

BEGIN_MESSAGE_MAP(CAppDoc, CDocument)
	//{{AFX_MSG_MAP(CAppDoc)
		// NOTE - the ClassWizard will add and remove mapping macros here.
		//    DO NOT EDIT what you see in these blocks of generated code!
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CAppDoc construction/destruction

CAppDoc::CAppDoc()
: irc::CIrcDefaultMonitor(g_ircSession), m_pSystemView(NULL)
{
	IRC_MAP_ENTRY(CAppDoc, "JOIN", OnIrc_JOIN)
	IRC_MAP_ENTRY(CAppDoc, "KICK", OnIrc_KICK)
	IRC_MAP_ENTRY(CAppDoc, "MODE", OnIrc_MODE)
	IRC_MAP_ENTRY(CAppDoc, "NICK", OnIrc_NICK)
	IRC_MAP_ENTRY(CAppDoc, "PART", OnIrc_PART)
	IRC_MAP_ENTRY(CAppDoc, "PRIVMSG", OnIrc_PRIVMSG)
	IRC_MAP_ENTRY(CAppDoc, "002", OnIrc_YOURHOST)
}

CAppDoc::~CAppDoc()
{
}

/////////////////////////////////////////////////////////////////////////////
// CAppDoc serialization

void CAppDoc::Serialize(CArchive& ar)
{
	/*if (ar.IsStoring())
	{
		// TODO: add storing code here
	}
	else
	{
		// TODO: add loading code here
	}*/
}

/////////////////////////////////////////////////////////////////////////////
// CAppDoc diagnostics

#ifdef _DEBUG
void CAppDoc::AssertValid() const
{
	CDocument::AssertValid();
}

void CAppDoc::Dump(CDumpContext& dc) const
{
	CDocument::Dump(dc);
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CAppDoc commands

BOOL CAppDoc::OnNewDocument()
{
	ASSERT(!g_ircSession);
	POSITION pos=GetFirstViewPosition();
	ASSERT(pos);
	m_pSystemView=GetNextView(pos);

	CConnectDlg dlg;
	CString sDefault;
	sDefault.LoadString(IDS_SERVER);
	dlg.m_sServer=AfxGetApp()->GetProfileString("Settings","Server",sDefault);
	dlg.m_sPort=AfxGetApp()->GetProfileString("Settings","Port",NULL);
	dlg.m_sNick=AfxGetApp()->GetProfileString("Settings","Nick",NULL);
	dlg.m_sUserID=AfxGetApp()->GetProfileString("Settings","UserID",NULL);
	dlg.m_sFullName=AfxGetApp()->GetProfileString("Settings","FullName",NULL);

	if(dlg.m_sPort.IsEmpty())
	dlg.m_sPort.LoadString(IDS_PORT);		// Load default
	if(dlg.m_sNick.IsEmpty())
	dlg.m_sNick.LoadString(IDS_NICK);		// Load default
	if(dlg.m_sUserID.IsEmpty())
	dlg.m_sUserID.LoadString(IDS_USERID);	// Load default
	if(dlg.m_sFullName.IsEmpty())
	dlg.m_sFullName.LoadString(IDS_FNAME);	// Load default

	/*dlg.m_sServer = _T("irc.ircnet.ru");
	dlg.m_sPort = _T("6667");
	dlg.m_sNick = _T("Dude");
	dlg.m_sUserID = _T("ko");
	dlg.m_sFullName = _T("ko");*/

	if(IDOK!=dlg.DoModal())
	return FALSE;

	char svBuff[256];
	lstrcpy(svBuff,dlg.m_sServer);
	char* svPort=BreakString(svBuff,":");
	if(svPort) {
		dlg.m_sPort=svPort;
		dlg.m_sServer=svBuff;
	}
	AfxGetApp()->WriteProfileString("Settings","Server",dlg.m_sServer);
	AfxGetApp()->WriteProfileString("Settings","Port",dlg.m_sPort);
	AfxGetApp()->WriteProfileString("Settings","Nick",dlg.m_sNick);
	AfxGetApp()->WriteProfileString("Settings","UserID",dlg.m_sUserID);
	AfxGetApp()->WriteProfileString("Settings","FullName",dlg.m_sFullName);

	/* Set this document object as the session's monitor. */
	g_ircSession.AddMonitor(this);

	CIrcSessionInfo si;
	si.sServer = dlg.m_sServer;
	si.iPort = atoi(dlg.m_sPort);
	si.sNick = dlg.m_sNick;
	si.sUserID = dlg.m_sUserID;
	si.sFullName = dlg.m_sFullName;
	si.sPassword = dlg.m_sPassword;
	si.bIdentServer = true;
	si.iIdentServerPort = 113;
	si.sIdentServerType = "UNIX";

	bool m_bOk=g_ircSession.Connect(si);
	if(!m_bOk)
	return FALSE;

	SetTitle(g_ircSession.GetInfo().sNick.c_str());

	if(g_bLogEnable) {
		wsprintf(svBuff,"Log file open, %s\r\n",LogDateTime());
		log((char*)theApp.m_sLogFilename.operator LPCTSTR(),svBuff);
	}
	return TRUE;
}

void CAppDoc::DeleteContents() 
{
	g_ircSession.Disconnect();
	g_ircSession.RemoveMonitor(this);
	m_pSystemView=NULL;
	
	CDocument::DeleteContents();
}

////////////////////////////////////////////////////////////

bool CAppDoc::OnIrc_YOURHOST(const CIrcMessage* pmsg)
{
	CIrcDefaultMonitor::OnIrc_YOURHOST(pmsg);

	// currently we only have one view.
	// name it with the host's name
	ASSERT(m_pSystemView != NULL);

	((CAppView*)m_pSystemView)->SetName(
	g_ircSession.GetInfo().sServerName.c_str());
	m_pSystemView->GetParent()->SetWindowText(
	g_ircSession.GetInfo().sServerName.c_str());

	return false;
}

bool CAppDoc::OnIrc_NICK(const CIrcMessage* pmsg)
{
	CIrcDefaultMonitor::OnIrc_NICK(pmsg);

	/*if(pmsg->prefix.sNick == m_session.GetInfo().sNick &&
	(pmsg->parameters.size() > 0) )
	{

	}*/

	return false;
}

bool CAppDoc::OnIrc_PRIVMSG(const CIrcMessage* pmsg)
{
	CString sName;
	if( pmsg->parameters[0][0] == '#' || !pmsg->m_bIncoming )
	sName = pmsg->parameters[0].c_str();
	else
	sName = pmsg->prefix.sNick.c_str();
		
	CAppView* pView = (CAppView*)FindView(sName);
	if( pView )
	pView->OnUpdate(NULL, (LPARAM)pmsg, NULL);

	return true;
}

bool CAppDoc::OnIrc_JOIN(const CIrcMessage* pmsg)
{
	CAppView* pView = (CAppView*)FindView(pmsg->parameters[0].c_str());
	if( pView )
	pView->OnUpdate(NULL, (LPARAM)pmsg, NULL);

	return true;
}

bool CAppDoc::OnIrc_PART(const CIrcMessage* pmsg)
{
	if( !pmsg->prefix.sNick.length() || pmsg->prefix.sNick == m_session.GetInfo().sNick )
		return false;

	CAppView* pView = (CAppView*)FindView(pmsg->parameters[0].c_str());
	if( pView )
		pView->OnUpdate(NULL, (LPARAM)pmsg, NULL);

	return true;
}

bool CAppDoc::OnIrc_KICK(const CIrcMessage* pmsg)
{
	if( !pmsg->prefix.sNick.length() )
	return false;

	CAppView* pView = (CAppView*)FindView(pmsg->parameters[0].c_str());
	if(pView)
	pView->OnUpdate(NULL, (LPARAM)pmsg, NULL);

	return true;
}

bool CAppDoc::OnIrc_MODE(const CIrcMessage* pmsg)
{
	if( !pmsg->prefix.sNick.length() )
	return false;

	if( pmsg->prefix.sNick == m_session.GetInfo().sNick )
	return false;

	CAppView* pView = (CAppView*)FindView(pmsg->parameters[0].c_str());
	if( pView )
	pView->OnUpdate(NULL, (LPARAM)pmsg, NULL);

	return true;
}

void CAppDoc::OnIrcDefault(const CIrcMessage* pmsg)
{
	CIrcDefaultMonitor::OnIrcDefault(pmsg);

	if( pmsg && m_session.GetInfo().sServerName.length() )
	{
		CAppView* pView = (CAppView*)FindView(
						m_session.GetInfo().sServerName.c_str());
		if( pView )
			pView->OnUpdate(NULL, (LPARAM)pmsg, NULL);
	}
	else
	UpdateAllViews(NULL, (LPARAM)pmsg);
}

void CAppDoc::OnIrcDisconnected()
{
	AfxGetMainWnd()->PostMessage(WM_COMMAND, ID_FILE_CLOSE);
}

CView* CAppDoc::FindView(LPCTSTR lpszName)
{
	POSITION pos = GetFirstViewPosition();
	while( pos )
	{
		CAppView* pView = (CAppView*)GetNextView(pos);

		if(0==strcmpi(pView->GetName(), lpszName))
		return pView;
	}

	return CreateNewView(lpszName);
}

CView* CAppDoc::CreateNewView(LPCTSTR lpszName)
{
	CDocTemplate* pTmp = GetDocTemplate();
	CFrameWnd* pFrame = pTmp->CreateNewFrame(this, NULL);
	ASSERT(pFrame != NULL);
	pFrame->SetWindowText(lpszName);
	pFrame->ActivateFrame();
	pFrame->ShowOwnedWindows(TRUE);

	POSITION pos = GetFirstViewPosition();
	while(pos)
	{
		CAppView* pView = (CAppView*)GetNextView(pos);
		if( !pView->GetName() || !lstrlen(pView->GetName()) )
		{
			pView->SetName(lpszName);
			pView->SetWindowText(lpszName);
			return pView;
		}
	}
	return NULL;
}
