// AppView.cpp

#include "stdafx.h"
#include "App.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

DWORD Aqua=RGB(0,180,180);
DWORD Black=RGB(0,0,0);
DWORD Blue=RGB(0,0,255);
DWORD Green=RGB(0,128,0);
DWORD Red=RGB(255,0,0);
DWORD Brown=RGB(128,0,0);
DWORD Yellow=RGB(255,255,0);
DWORD White=RGB(255,255,255);
DWORD Grey=RGB(192,192,192);
DWORD Grey2=RGB(128,128,128);
/*COLORREF g_clrMsg = Black;
COLORREF g_clrNick = Red;
COLORREF g_clrUnNicked = Green;
COLORREF g_clrCmd = Blue;
COLORREF g_clrNotice = Grey2;
COLORREF g_clrBkg = Black;*/
COLORREF g_clrMsg, g_clrNick, g_clrUnNicked;
COLORREF g_clrCmd, g_clrNotice, g_clrBkg;

IMPLEMENT_DYNCREATE(CAppView, CView)

BEGIN_MESSAGE_MAP(CAppView, CView)
	//{{AFX_MSG_MAP(CAppView)
	ON_WM_CREATE()
	ON_WM_SIZE()
	ON_WM_SETFOCUS()
	ON_WM_DESTROY()
	//}}AFX_MSG_MAP
	ON_MESSAGE(WM_RETURNPRESSED, OnReturnPressed)
	ON_MESSAGE(RICHEDIT_WM_RBUTTONDOWN, OnRichEdit_RButtonDown)
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CAppView construction/destruction

CAppView::CAppView()
{
}
CAppView::~CAppView()
{
}

BOOL CAppView::PreCreateWindow(CREATESTRUCT& cs) {
	cs.dwExStyle &= ~WS_EX_CLIENTEDGE;
	return CView::PreCreateWindow(cs);
}

/////////////////////////////////////////////////////////////////////////////
// CAppView drawing

void CAppView::OnDraw(CDC* pDC) {
	CAppDoc* pDoc = GetDocument();
	ASSERT_VALID(pDoc);
	// TODO: add draw code for native data here
}

/////////////////////////////////////////////////////////////////////////////
// CAppView diagnostics

#ifdef _DEBUG
void CAppView::AssertValid() const
{
	CView::AssertValid();
}

void CAppView::Dump(CDumpContext& dc) const
{
	CView::Dump(dc);
}

CAppDoc* CAppView::GetDocument() // non-debug version is inline
{
	ASSERT(m_pDocument->IsKindOf(RUNTIME_CLASS(CAppDoc)));
	return (CAppDoc*)m_pDocument;
}
#endif //_DEBUG

/////////////////////////////////////////////////////////////////////////////
// CAppView message handlers

int CAppView::OnCreate(LPCREATESTRUCT lpCreateStruct) {
	if(-1==CView::OnCreate(lpCreateStruct))
	return -1;
	if(!m_RichEdit.Create(WS_CHILD|WS_VISIBLE|WS_VSCROLL|WS_HSCROLL|ES_MULTILINE|ES_READONLY, CRect(), this, 100))
	return -1;
	if(!m_edit.Create(WS_CHILD|WS_VISIBLE|ES_AUTOHSCROLL, CRect(), this, 101) )
	return -1;

	m_RichEdit.ModifyStyleEx(WS_EX_CLIENTEDGE,0);
	m_edit.ModifyStyleEx(0,WS_EX_STATICEDGE);

	HFONT Font=CreateFontIndirect(&g_lfDefFont);
	m_RichEdit.SendMessage(WM_SETFONT,(WPARAM)Font);
	m_RichEdit.SendMessage(EM_SETBKGNDCOLOR,0,(LPARAM)g_clrBkg);
	m_edit.SendMessage(WM_SETFONT,(WPARAM)GetStockObject(SYSTEM_FIXED_FONT));

	/* Set word-wrapping off */
	m_RichEdit.SetTargetDevice(NULL,1);

	if(m_RichEdit) { /* Set subroutine RichEdit_WndProc */
		DWORD dwStyle=GetWindowLong(m_RichEdit.GetSafeHwnd(),GWL_WNDPROC);
		SetWindowLong(m_RichEdit.GetSafeHwnd(),GWL_USERDATA,dwStyle);
		SetWindowLong(m_RichEdit.GetSafeHwnd(),GWL_WNDPROC,(LONG)RichEdit_WndProc);
	}
	return 0;
}

void CAppView::OnDestroy() 
{
	CView::OnDestroy();
	if(m_sName.GetLength() && '#'==m_sName[0]) {
		CString s;
		s.Format("PART %s", m_sName);
		g_ircSession << CIrcMessage(s);
	}
}

void CAppView::OnSize(UINT nType, int cx, int cy) {
	CView::OnSize(nType, cx, cy);
	if(SIZE_MINIMIZED!=nType) {
		static const int nHeight=28;
		m_RichEdit.MoveWindow(0,0,cx,cy-nHeight);
		m_edit.MoveWindow(0,cy-nHeight,cx,nHeight);
	}
}

void CAppView::OnSetFocus(CWnd* pOldWnd) {
	CView::OnSetFocus(pOldWnd);
	m_edit.SetFocus();
}

void CAppView::SetDefaultTextColor(COLORREF clr) {
	CRichEditFormat f;
	f.dwMask = CFM_COLOR;
	f.crTextColor = clr;
	m_RichEdit.SendMessage(EM_SETCHARFORMAT,SCF_SELECTION,(LPARAM)&f);
}

CString CAppView::Parse(CString str) {
	CString strResult;
	CString strAppend;
	strAppend.Empty();
	int i;
	for(i=0;i<str.GetLength();++i) {
		if('\t'==str[i]	||
			2==str[i]	||
			0x5B==str[i]||
			0x1F==str[i]) {
			++i;
			continue;
		}
		strAppend+=str[i];
	}
	strResult += strAppend;
	return strResult;
}

void CAppView::SetName(LPCTSTR sName) {
	m_sName = sName;
}

LPCTSTR CAppView::GetName() const
{
	return m_sName;
}

void CAppView::OnInitialUpdate() {
	CView::OnInitialUpdate();
	static BOOL bInit;
	if(!bInit) {
		CString sDefault, sChannel;
		sDefault.LoadString(IDS_CHANNEL); /* "Old-dos" */
		sChannel=AfxGetApp()->GetProfileString("Settings","Channel",sDefault);
		if('#'==sChannel[0])
		sChannel=sChannel.Mid(1);
		CString sJoin;
		sJoin.Format("/join #%s",sChannel);
		m_edit.SetWindowText(sJoin);
		int l=m_edit.GetWindowTextLength();
		m_edit.SetSel(l,l);
		bInit=TRUE;
	}
}

BOOL CAppView::OnCmdMsg(UINT nID, int nCode, void* pExtra, AFX_CMDHANDLERINFO* pHandlerInfo) 
{
	BOOL bRet = CView::OnCmdMsg(nID, nCode, pExtra, pHandlerInfo);
/*#if 0
	if(100==nID) {
		if(EN_SETFOCUS==nCode)
		HideCaret();
		else if(EN_KILLFOCUS==nCode)
		ShowCaret();
	}
#endif*/
	return bRet;
}

BOOL CAppView::IsActiveViewFirst() {
	/*
	* Is active view first?
	*/
	int nTotal=0;
	BOOL bRet=FALSE;
	CMainFrame* pMainFrame=(CMainFrame*)AfxGetMainWnd();
	CMDIChildWnd* pActive=pMainFrame->MDIGetActive();
	if(pActive) {
		POSITION ptemp=AfxGetApp()->GetFirstDocTemplatePosition();
		while(ptemp) {
			CDocTemplate* temp=AfxGetApp()->GetNextDocTemplate(ptemp);
			POSITION pdoc=temp->GetFirstDocPosition();
			while(pdoc) {
				CDocument* doc=temp->GetNextDoc(pdoc);
				POSITION pview=doc->GetFirstViewPosition();
				while(pview) {
					CFrameWnd* pCurr=doc->GetNextView(pview)->GetParentFrame();
					if(pCurr) {
						if(pActive==pCurr) {
							if(!nTotal)
							bRet=TRUE;
						}
						++nTotal;
					}
				}
			}
		} /* End "while(ptemp)" */
	} /* End if(pWnd) */
	return bRet;
}

LRESULT CAppView::OnRichEdit_RButtonDown(WPARAM, LPARAM) {
	long startPos,endPos;
	HMENU Menu=CreatePopupMenu();
	if(!Menu) return 0;
	if(IsActiveViewFirst()) {
		CString sJoin, sNames;
		sJoin.Format("Connect /join #");
		sNames.Format("Show Users /names #");
		InsertMenu(Menu,-1,MF_BYPOSITION,IDM_IRC_JOIN,sJoin);
 		InsertMenu(Menu,-1,MF_SEPARATOR,-1,NULL);
		InsertMenu(Menu,-1,MF_BYPOSITION,IDM_IRC_NAMES,sNames);
 		InsertMenu(Menu,-1,MF_SEPARATOR,-1,NULL);
	}
	InsertMenu(Menu,-1,MF_BYPOSITION,IDM_COPY,"Copy");
	InsertMenu(Menu,-1,MF_BYPOSITION,IDM_COPY_ALL,"Copy All");
 	InsertMenu(Menu,-1,MF_SEPARATOR,-1,NULL);
	InsertMenu(Menu,-1,MF_BYPOSITION,IDM_CHANGE_FONT,"Change Font");
 	InsertMenu(Menu,-1,MF_SEPARATOR,-1,NULL);
	UINT uFlags=MF_BYPOSITION | MF_DISABLED | MF_GRAYED;
	if(g_bLogEnable) {
		DWORD dwFileSize;
		if(CheckFileExists((char*)theApp.m_sLogFilename.operator LPCTSTR(),dwFileSize))
			uFlags=MF_BYPOSITION;
	}
	InsertMenu(Menu,-1,uFlags,IDM_SHOW_LOG,"Show Log");
	POINT pt;
	GetCursorPos(&pt);
	SetForegroundWindow();
	int cmd=TrackPopupMenu(Menu,TPM_RETURNCMD|TPM_RIGHTBUTTON,pt.x,pt.y,0,GetSafeHwnd(),NULL);
	switch(cmd) {
	case IDM_IRC_JOIN: {
		CString sDefault;
		sDefault.LoadString(IDS_CHANNEL);
		CChannelDlg dlg;
		dlg.m_sTitle="Join to channel";
		dlg.m_sChannel=AfxGetApp()->GetProfileString("Settings","Channel",sDefault);
		if(IDOK==dlg.DoModal()) {
			CString sChannel, sNames;
			sChannel.Empty();
			sChannel=dlg.m_sChannel;
			if('#'!=sChannel[0])
			sNames.Format("join #%s",sChannel);
			else
			sNames.Format("join %s",sChannel);
			if(g_ircSession)
			g_ircSession << irc::CIrcMessage(sNames);
			AfxGetApp()->WriteProfileString("Settings","Channel",dlg.m_sChannel);
		}
	} /* End "case IDM_IRC_JOIN" */
	break;
	case IDM_IRC_NAMES: {
		CString sDefault;
		sDefault.LoadString(IDS_CHANNEL);
		CChannelDlg dlg;
		dlg.m_sTitle="Show names to channel";
		dlg.m_sChannel=AfxGetApp()->GetProfileString("Settings","Channel",sDefault);
		if(IDOK==dlg.DoModal()) {
			CString sChannel, sNames;
			sChannel.Empty();
			sChannel=dlg.m_sChannel;
			if('#'!=sChannel[0])
			sNames.Format("names #%s",sChannel);
			else
			sNames.Format("names %s",sChannel);
			if(g_ircSession)
			g_ircSession << irc::CIrcMessage(sNames);
			AfxGetApp()->WriteProfileString("Settings","Channel",dlg.m_sChannel);
		}
	} /* End "case IDM_IRC_NAMES" */
	break;
	case IDM_COPY:
	m_RichEdit.Copy();
	break;
	case IDM_COPY_ALL:
	m_RichEdit.GetSel(startPos,endPos);
	m_RichEdit.SetSel(0,-1);
	m_RichEdit.Copy();
	m_RichEdit.SetSel(startPos,endPos);
	break;
	case IDM_CHANGE_FONT: {
		LOGFONT plfOld=g_lfDefFont;
		appSetFont(m_RichEdit.GetSafeHwnd(),&plfOld);
		g_lfDefFont=plfOld;
		m_RichEdit.Invalidate();
	}
	break;
	case IDM_SHOW_LOG: {
		HINSTANCE ShellExError=ShellExecute(NULL,"open",theApp.m_sLogFilename,NULL,NULL,SW_SHOWNORMAL);
		if(INT_PTR(ShellExError)<=32) {
			char svBuff[256];
			wsprintf(svBuff,"Cannot open\n\n\"%s\"",theApp.m_sLogFilename);
			mb(svBuff);
			}
		} /* End "case IDM_SHOW_LOG" */
	} /* End "switch(cmd)" */
	DestroyMenu(Menu);
	Invalidate();
	return 0;
}

LRESULT CAppView::OnReturnPressed(WPARAM, LPARAM) {
	CString s;
	m_edit.GetWindowText(s);
	int n=s.GetLength();
	if(n) {
		if(n<64) { /* Write last channel. */
			char svBuff[256];
			lstrcpy(svBuff,s);
			if(strstr(svBuff,"n #")) {
				char* p=BreakString(svBuff,"#");
				if(p)
					AfxGetApp()->WriteProfileString("Settings","Channel",p);
			}
		}
		long len=m_RichEdit.GetTextLength();
		if('/'!=s[0])
		s = "PRIVMSG " + m_sName + " :" + s;
		else
		s = s.Mid(1);
		if(g_ircSession)
		g_ircSession << irc::CIrcMessage(s);
		m_edit.SetWindowText(_T(""));
		long total=len + s.GetLength(); 
		m_RichEdit.SetSel(total,total);
	}
	return 0;
}

void CAppView::OnUpdate(CView*, LPARAM lParam, CObject*) {
	int l=m_RichEdit.GetWindowTextLength();
	m_RichEdit.SetSel(l,l);
	m_RichEdit.SendMessage(EM_SCROLLCARET);
	//m_RichEdit.Invalidate();

	const irc::CIrcMessage* pIrc=(const irc::CIrcMessage*)lParam;
	if(!pIrc)
	return;
	
	CString strBuffer;
	strBuffer.Empty();
	BOOL bBeep=FALSE;

	if(pIrc->prefix.sNick.length()) {
		strBuffer +=pIrc->prefix.sNick.c_str();
		strBuffer +=" ";
		SetDefaultTextColor(g_clrNick);
		m_RichEdit.ReplaceSel((pIrc->prefix.sNick + " ").c_str());
		SetDefaultTextColor(g_clrCmd);
		bBeep=TRUE;
		strBuffer +=" ";
	} else {
		SetDefaultTextColor(g_clrUnNicked);
		strBuffer +="=>";
	}
	m_RichEdit.ReplaceSel((pIrc->sCommand + " ").c_str());
	
 	if("PRIVMSG"==pIrc->sCommand)
		SetDefaultTextColor(g_clrMsg);
	else
		SetDefaultTextColor(g_clrNotice);

	CString str, strOut;
	for(int i=0; i<pIrc->parameters.size(); ++i) {
		str=pIrc->parameters[i].c_str();
		strOut=Parse(str);
		strOut +=" ";
		m_RichEdit.ReplaceSel(strOut);
		if(g_bLogEnable) { /* Write to log file. */
			strOut+=" ";
			strBuffer+=strOut;
		}
	}
	m_RichEdit.ReplaceSel("\r\n");

	if(g_bLogEnable) {
		strBuffer+="\r\n";
		log((char*)theApp.m_sLogFilename.operator LPCTSTR(),(char*)strBuffer.operator LPCTSTR(),FALSE);
	}
	if(bBeep) { /* Play sound. */
		BOOL bPlaySound=AfxGetApp()->GetProfileInt("Settings","PlaySound",FALSE);
		if(bPlaySound) {
			CString s=AfxGetApp()->GetProfileString("Settings","Sound File",NULL);
			if(!s.IsEmpty()) {
				//if(!IsActiveViewFirst())
				Beep((char*)s.operator LPCTSTR());
			}
		}
	} /* End "if(bBeep)" */
}
