// AppView.h

#pragma once

class CAppView : public CView
{
protected: // create from serialization only
	DECLARE_DYNCREATE(CAppView)
	CAppView();

	CString Parse(CString);
	BOOL IsActiveViewFirst();

// Attributes
public:
	CAppDoc* GetDocument();

// Operations
public:

// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAppView)
	public:
	virtual void OnDraw(CDC* pDC);  // overridden to draw this view
	virtual BOOL PreCreateWindow(CREATESTRUCT& cs);
	virtual void OnUpdate(CView* pSender, LPARAM lHint, CObject* pHint);
	virtual void OnInitialUpdate();
	virtual BOOL OnCmdMsg(UINT nID, int nCode, void* pExtra, AFX_CMDHANDLERINFO* pHandlerInfo);
	//}}AFX_VIRTUAL

// Implementation

public:
	LPCTSTR GetName() const;
	void SetName(LPCTSTR lpszName);
	virtual ~CAppView();
#ifdef _DEBUG
	virtual void AssertValid() const;
	virtual void Dump(CDumpContext& dc) const;
#endif

protected:
	struct CRichEditFormat : public CHARFORMAT
	{
		CRichEditFormat() {
			memset(this,0,sizeof(CHARFORMAT));
			cbSize=sizeof(CHARFORMAT);
		}
	};

// Generated message map functions
protected:
	CRichEditCtrl m_RichEdit;
	CEditEx m_edit;
	CString m_sName;

	//{{AFX_MSG(CAppView)
	afx_msg int OnCreate(LPCREATESTRUCT lpCreateStruct);
	afx_msg void OnSize(UINT nType, int cx, int cy);
	afx_msg void OnSetFocus(CWnd* pOldWnd);
	afx_msg void OnDestroy();
	afx_msg void OnRButtonDown(UINT nFlags, CPoint point);
	//}}AFX_MSG
	afx_msg LRESULT OnReturnPressed(WPARAM, LPARAM);
	afx_msg LRESULT OnRichEdit_RButtonDown(WPARAM, LPARAM);
	DECLARE_MESSAGE_MAP()

	void SetDefaultTextColor(COLORREF rgb);
};

#ifndef _DEBUG  // debug version in AppView.cpp
inline CAppDoc* CAppView::GetDocument()
   { return (CAppDoc*)m_pDocument; }
#endif
