// ChannelDlg.cpp

#include "stdafx.h"
#include "App.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

CChannelDlg::CChannelDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CChannelDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CChannelDlg)
	m_sChannel = _T("");
	//}}AFX_DATA_INIT
}

void CChannelDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CChannelDlg)
	DDX_Control(pDX, IDC_CHANNEL, m_combo);
	DDX_Text(pDX, IDC_CHANNEL, m_sChannel);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CChannelDlg, CDialog)
	//{{AFX_MSG_MAP(CChannelDlg)
	ON_EN_CHANGE(IDC_CHANNEL, OnChange)
	ON_CBN_SELCHANGE(IDC_CHANNEL, OnCbnSelchange)
	ON_CBN_EDITCHANGE(IDC_CHANNEL, OnChange)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CChannelDlg message handlers

void CChannelDlg::OnOK() {
	CDialog::OnOK();
}
void CChannelDlg::OnChange() {
	UpdateButtons();
}
void CChannelDlg::OnCbnSelchange() {
	UpdateButtons();
}
void CChannelDlg::UpdateButtons() {
	GetDlgItem(IDOK)->EnableWindow(
	GetDlgItem(IDC_CHANNEL)->GetWindowTextLength()>0);
}

BOOL CChannelDlg::OnInitDialog() {
	CDialog::OnInitDialog();
	if(!m_sTitle.IsEmpty())
	SetWindowText(m_sTitle);
	HICON Icon=LoadIcon(g_hInstance,MAKEINTRESOURCE(IDI_CHANNEL));
	if(Icon) SendMessage(WM_SETICON,ICON_BIG,(LPARAM)Icon);
	UpdateButtons();
	char svBuff[MAX_PATH];
	int nIndex=0;
	if(m_combo.GetWindowTextLength()) {
		nIndex=m_combo.SendMessage(CB_GETCOUNT,0,0);
		m_combo.GetWindowText(svBuff,MAX_PATH);
		m_combo.SendMessage(CB_INSERTSTRING,nIndex,(LPARAM)(LPCTSTR)svBuff);
		++nIndex;
	}
	/* Fill ComboBox from file. */
	char svFname[MAX_PATH];
	wsprintf(svFname,"%sChannels.txt",appBaseDir());
	FILE* File=fopen(svFname,"rb");
	if(File) {
		while(fgets(svBuff,sizeof(svBuff),File)) {
			if(
				' '!=svBuff[0] &&
				'\t'!=svBuff[0] &&
				';'!=svBuff[0] &&
				'/'!=svBuff[0]
				) {
				if(strchr(svBuff,' '))
				*strchr(svBuff,' ')=0;
				if(strchr(svBuff,'\r'))
				*strchr(svBuff,'\r')=0;
				if(strchr(svBuff,'\n'))
				*strchr(svBuff,'\n')=0;
				if(svBuff[0]) {
					m_combo.SendMessage(CB_INSERTSTRING,nIndex,(LPARAM)(LPCTSTR)svBuff);
					++nIndex;
				}
			} // End "if(';')"
		} // End "while"
		fclose(File);
	} // End "if(File)"
	m_combo.SendMessage(CB_SETCURSEL,(LPARAM)0,0);
	return TRUE;
}
