// ClrDlg.cpp

#include "stdafx.h"
#include "App.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

CString m_sText(
"Nick Dude Cmd NOTICE Message\n"
"UnNicked  Cmd NOTICE Message\n"
"Nick Dude Cmd NOTICE Message\n");

CString m_sMsg("Message");
CString m_sNick("Nick Dude");
CString m_sUnNicked("UnNicked");
CString m_sCmd("Cmd");
CString m_sNotice("NOTICE");

/////////////////////////////////////////////////////////////////////////////
// CClrDlg dialog

CClrDlg::CClrDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CClrDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CClrDlg)
		// NOTE: the ClassWizard will add member initialization here
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDI_OPTIONS);
}

void CClrDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CClrDlg)
		// NOTE: the ClassWizard will add DDX and DDV calls here
	DDX_Control(pDX, IDC_RICHEDIT1, m_RichEdit);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CClrDlg, CDialog)
	//{{AFX_MSG_MAP(CClrDlg)
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_WM_DRAWITEM()

#if _MSC_VER == 1200			// MSVC++ 6.0
	//ON_BN_CLICKED(IDC_BT_EXIT, OnExitProgram)
	ON_BN_CLICKED(IDC_BUTTON1, OnButton1)
	ON_BN_CLICKED(IDC_BUTTON2, OnButton2)
	ON_BN_CLICKED(IDC_BUTTON3, OnButton3)
	ON_BN_CLICKED(IDC_BUTTON4, OnButton4)
	ON_BN_CLICKED(IDC_BUTTON5, OnButton5)
	ON_BN_CLICKED(IDC_BUTTON6, OnButton6)
	ON_BN_CLICKED(IDC_BUTTON7, OnButton7)
#else
	//ON_BN_CLICKED(IDC_BT_EXIT, &CClrDlg::OnExitProgram)
	ON_BN_CLICKED(IDC_BUTTON1, &CClrDlg::OnButton1)
#endif

	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CClrDlg message handlers

BOOL CClrDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	// TODO: Add extra initialization here
	int FontSize=22;
	HFONT hFont=CreateFont(FontSize,0,0,0,FW_NORMAL,0,0,0,GetACP(),0,0,0,0,"Tahoma");
	m_RichEdit.SendMessage(WM_SETFONT,(WPARAM)hFont);
	m_RichEdit.SendMessage(EM_SETBKGNDCOLOR,0,(LPARAM)g_clrBkg);

	/* Fill RichEdit message */
	m_RichEdit.SetWindowText(m_sText);

	/* Set color */
	RichEdit_ChgTxtClr(m_sMsg, g_clrMsg);
	RichEdit_ChgTxtClr(m_sNick, g_clrNick);
	RichEdit_ChgTxtClr(m_sUnNicked, g_clrUnNicked);
	RichEdit_ChgTxtClr(m_sCmd, g_clrCmd);
	RichEdit_ChgTxtClr(m_sNotice, g_clrNotice);
	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CClrDlg::RichEdit_ChgTxtClr(CString& Match, COLORREF crTextColor)
{
	long lenMatch=Match.GetLength();
	long lenTotal=m_RichEdit.GetTextLength();
	if(!lenMatch || !lenTotal)
	return;

	CString str;
	m_RichEdit.GetWindowText(str);

	CHARFORMAT f;
	f.cbSize=sizeof(f);
	f.dwMask=CFM_BOLD | CFM_COLOR;
	f.dwEffects=CFE_BOLD |~CFE_AUTOCOLOR;
	f.crTextColor=crTextColor;

	long startPos;
	for(long n=0;n<lenTotal-lenMatch;++n) {
		if(0==memcmp(str.operator LPCTSTR()+n,Match,lenMatch)) {
			startPos=n;
			n+=lenMatch;
			m_RichEdit.SetSel(startPos,n);
			m_RichEdit.SendMessage(EM_SETCHARFORMAT,SCF_SELECTION,(LPARAM)&f);
		}
	}
}

void CClrDlg::OnButton1()
{
	COLORREF clrCurrent=g_clrMsg;
	g_clrMsg=appChooseColor(m_RichEdit.GetSafeHwnd(),clrCurrent);
	RichEdit_ChgTxtClr(m_sMsg,g_clrMsg);
	CButton* btn=(CButton*)GetDlgItem(IDC_BUTTON1);
	btn->InvalidateRect(NULL,TRUE);
}

void CClrDlg::OnButton2()
{
	COLORREF clrCurrent=g_clrNick;
	g_clrNick=appChooseColor(m_RichEdit.GetSafeHwnd(),clrCurrent);
	RichEdit_ChgTxtClr(m_sNick,g_clrNick);
	CButton* btn=(CButton*)GetDlgItem(IDC_BUTTON2);
	btn->InvalidateRect(NULL,TRUE);
}

void CClrDlg::OnButton3()
{
	COLORREF clrCurrent=g_clrUnNicked;
	g_clrUnNicked=appChooseColor(m_RichEdit.GetSafeHwnd(),clrCurrent);
	RichEdit_ChgTxtClr(m_sUnNicked,g_clrUnNicked);
	CButton* btn=(CButton*)GetDlgItem(IDC_BUTTON3);
	btn->InvalidateRect(NULL,TRUE);
}

void CClrDlg::OnButton4()
{
	COLORREF clrCurrent=g_clrCmd;
	g_clrCmd=appChooseColor(m_RichEdit.GetSafeHwnd(),clrCurrent);
	RichEdit_ChgTxtClr(m_sCmd,g_clrCmd);
	CButton* btn=(CButton*)GetDlgItem(IDC_BUTTON4);
	btn->InvalidateRect(NULL,TRUE);
}

void CClrDlg::OnButton5()
{
	COLORREF clrCurrent=g_clrNotice;
	g_clrNotice=appChooseColor(m_RichEdit.GetSafeHwnd(),clrCurrent);
	RichEdit_ChgTxtClr(m_sNotice,g_clrNotice);
	CButton* btn=(CButton*)GetDlgItem(IDC_BUTTON5);
	btn->InvalidateRect(NULL,TRUE);
}

void CClrDlg::OnButton6()
{
	COLORREF clrCurrent=g_clrBkg;
	g_clrBkg=appChooseColor(m_RichEdit.GetSafeHwnd(),clrCurrent);
	m_RichEdit.SendMessage(EM_SETBKGNDCOLOR,0,(LPARAM)g_clrBkg);
	CButton* btn=(CButton*)GetDlgItem(IDC_BUTTON6);
	btn->InvalidateRect(NULL,TRUE);
}

void CClrDlg::OnDrawItem(int nIDCtl, LPDRAWITEMSTRUCT lpDrawItemStruct)
{
	char svBuf[32];
	::GetWindowText(lpDrawItemStruct->hwndItem,svBuf,32);

	COLORREF crColor;
	switch(lpDrawItemStruct->CtlID) {
		case IDC_BUTTON1:
			crColor=g_clrMsg;
			break;
		case IDC_BUTTON2:
			crColor=g_clrNick;
			break;
		case IDC_BUTTON3:
			crColor=g_clrUnNicked;
			break;
		case IDC_BUTTON4:
			crColor=g_clrCmd;
			break;
		case IDC_BUTTON5:
			crColor=g_clrNotice;
			break;
		case IDC_BUTTON6:
			crColor=g_clrBkg;
			break;
	}

	FillRect(lpDrawItemStruct->hDC,&lpDrawItemStruct->rcItem,CreateSolidBrush(crColor));
	if((lpDrawItemStruct->itemState & ODS_SELECTED))
	DrawEdge(lpDrawItemStruct->hDC,&lpDrawItemStruct->rcItem,EDGE_SUNKEN,BF_RECT);
	else
	DrawEdge(lpDrawItemStruct->hDC,&lpDrawItemStruct->rcItem,EDGE_RAISED,BF_RECT);

	if(Black==crColor)
	SetTextColor(lpDrawItemStruct->hDC,White);
	else
	SetTextColor(lpDrawItemStruct->hDC,GetSysColor(COLOR_WINDOWTEXT));

	SetBkMode(lpDrawItemStruct->hDC,TRANSPARENT);
	DrawText(lpDrawItemStruct->hDC,svBuf,lstrlen(svBuf),&lpDrawItemStruct->rcItem,DT_CENTER|DT_VCENTER|DT_SINGLELINE);
}

void CClrDlg::OnButton7()
{
	/* Reset default */
	int idResponse=MessageBox(
	"Reset color default - continued?",
	theApp.m_sAppname,MB_YESNO | MB_ICONQUESTION |
	MB_SETFOREGROUND | MB_SYSTEMMODAL);
	if(IDNO==idResponse) {
		return;
	}
	g_clrMsg = Black;
	g_clrNick = Red;
	g_clrUnNicked = Green;
	g_clrCmd = Blue;
	g_clrNotice = Grey2;
	g_clrBkg = White;

	RichEdit_ChgTxtClr(m_sMsg, g_clrMsg);
	CButton* btn=(CButton*)GetDlgItem(IDC_BUTTON1);
	btn->InvalidateRect(NULL,TRUE);

	RichEdit_ChgTxtClr(m_sNick, g_clrNick);
	btn=(CButton*)GetDlgItem(IDC_BUTTON2);
	btn->InvalidateRect(NULL,TRUE);

	RichEdit_ChgTxtClr(m_sUnNicked, g_clrUnNicked);
	btn=(CButton*)GetDlgItem(IDC_BUTTON3);
	btn->InvalidateRect(NULL,TRUE);

	RichEdit_ChgTxtClr(m_sCmd, g_clrCmd);
	btn=(CButton*)GetDlgItem(IDC_BUTTON4);
	btn->InvalidateRect(NULL,TRUE);

	RichEdit_ChgTxtClr(m_sNotice, g_clrNotice);
	btn=(CButton*)GetDlgItem(IDC_BUTTON5);
	btn->InvalidateRect(NULL,TRUE);

	m_RichEdit.SendMessage(EM_SETBKGNDCOLOR,0,(LPARAM)g_clrBkg);
	btn=(CButton*)GetDlgItem(IDC_BUTTON6);
	btn->InvalidateRect(NULL,TRUE);
}
