// ConDlg.cpp

#include "stdafx.h"
#include "App.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

CConnectDlg::CConnectDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CConnectDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CConnectDlg)
	m_sServer = _T("");
	m_sPort = _T("");
	m_sNick = _T("");
	m_sUserID = _T("");
	m_sFullName = _T("");
	m_sPassword = _T("");
	//}}AFX_DATA_INIT
}

void CConnectDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CConnectDlg)
	DDX_Control(pDX, IDC_SERVER, m_combo);
	DDX_Text(pDX, IDC_SERVER, m_sServer);
	DDX_Text(pDX, IDC_PORT, m_sPort);
	DDX_Text(pDX, IDC_NICK, m_sNick);
	DDX_Text(pDX, IDC_USERID, m_sUserID);
	DDX_Text(pDX, IDC_FULLNAME, m_sFullName);
	DDX_Text(pDX, IDC_PASSWORD, m_sPassword);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CConnectDlg, CDialog)
	//{{AFX_MSG_MAP(CConnectDlg)
	ON_EN_CHANGE(IDC_SERVER, OnChange)
	ON_EN_CHANGE(IDC_PORT, OnChangePort)
	ON_EN_CHANGE(IDC_NICK, OnChange)
	ON_EN_CHANGE(IDC_USERID, OnChange)
	ON_EN_CHANGE(IDC_FULLNAME, OnChange)
	ON_EN_CHANGE(IDC_PASSWORD, OnChange)
	ON_CBN_SELCHANGE(IDC_SERVER, OnCbnSelchange)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CConnectDlg message handlers

void CConnectDlg::OnOK() {
	GetDlgItemText(IDC_PORT,m_sPort);
	int nPort=atoi(m_sPort);
	if(nPort>0xFFFF) {
		mb("Maximum the port number 65535");
		SendDlgItemMessage(IDC_PORT,EM_SETSEL,(WPARAM)m_sPort.GetLength(),(LPARAM)m_sPort.GetLength());
		m_sPort="";
		GetDlgItem(IDC_PORT)->SetFocus();
		return;
	}
	CDialog::OnOK();
}

void CConnectDlg::OnChange() {
	UpdateButtons();
}

void CConnectDlg::OnChangePort() {
	GetDlgItemText(IDC_PORT,m_sPort);
	int nPort=atoi(m_sPort);
	if(nPort>0xFFFF) {
		mb("Maximum the port number 65535");
		m_sPort="";
	}
	UpdateButtons();
}

void CConnectDlg::OnCbnSelchange() {
	CComboBox* combo=(CComboBox*)GetDlgItem(IDC_SERVER);
	if(combo) {
		int nIndex=combo->GetCurSel();
		if(CB_ERR!=nIndex) {
			char svBuff[256];
			SendDlgItemMessage(IDC_SERVER,CB_GETLBTEXT,nIndex,(LPARAM)svBuff);
			char* svPort=BreakString(svBuff,":");
			if(svPort) {
				CEdit* edit=(CEdit*)GetDlgItem(IDC_PORT);
				if(edit) edit->SetWindowText(svPort);
			}
		}
	}
}

void CConnectDlg::UpdateButtons() {
	GetDlgItem(IDOK)->EnableWindow(
	GetDlgItem(IDC_SERVER)->GetWindowTextLength() > 0 &&
	GetDlgItem(IDC_PORT)->GetWindowTextLength() > 0 &&
	GetDlgItem(IDC_NICK)->GetWindowTextLength() > 0 &&
	GetDlgItem(IDC_USERID)->GetWindowTextLength() > 0 &&
	GetDlgItem(IDC_FULLNAME)->GetWindowTextLength() > 0);
}

BOOL CConnectDlg::OnInitDialog() {
	CDialog::OnInitDialog();

	HICON Icon=LoadIcon(g_hInstance,MAKEINTRESOURCE(IDI_SPICH));
	if(Icon) SendMessage(WM_SETICON,ICON_BIG,(LPARAM)Icon);
	/* Set limit text 5 (65535 - maxumum). */
	SendDlgItemMessage(IDC_PORT,EM_SETLIMITTEXT,5,0);
	UpdateButtons();
	char svBuff[MAX_PATH];
	int nIndex=0;
	if(m_combo.GetWindowTextLength()) {
		nIndex=m_combo.SendMessage(CB_GETCOUNT,0,0);
		m_combo.GetWindowText(svBuff,MAX_PATH);
		m_combo.SendMessage(CB_INSERTSTRING,nIndex,(LPARAM)(LPCTSTR)svBuff);
		++nIndex;
	}
	/* Fill ComboBox from file. */
	char svFname[MAX_PATH];
	wsprintf(svFname,"%sServers.txt",appBaseDir());
	FILE* File=fopen(svFname,"rb");
	if(File) {
		while(fgets(svBuff,sizeof(svBuff),File)) {
			if(
				' '!=svBuff[0] &&
				'\t'!=svBuff[0] &&
				';'!=svBuff[0] &&
				'/'!=svBuff[0]
				) {
				if(strchr(svBuff,' '))
				*strchr(svBuff,' ')=0;
				if(strchr(svBuff,'\r'))
				*strchr(svBuff,'\r')=0;
				if(strchr(svBuff,'\n'))
				*strchr(svBuff,'\n')=0;
				if(svBuff[0]) {
					m_combo.SendMessage(CB_INSERTSTRING,nIndex,(LPARAM)(LPCTSTR)svBuff);
					++nIndex;
				}
			} // End "if(';')"
		} // End "while"
		fclose(File);
	} // End "if(File)"
	m_combo.SendMessage(CB_SETCURSEL,(LPARAM)0,0);
	return TRUE;
}
