// Helper.cpp

#include "stdafx.h"
#include "App.h"

void mb(char* Str) {
	UINT uType=MB_OK | MB_ICONINFORMATION |
	MB_SETFOREGROUND | MB_SYSTEMMODAL;
	int n=0;
	if(strstr(Str,"Failed") || strstr(Str,"Error"))
	++n;
	if(n) {
		uType &=~MB_ICONINFORMATION;
		uType |=MB_ICONWARNING;
	} MessageBox(GetActiveWindow(),Str,theApp.m_sWndname,uType);
	if(n)
	ExitProcess(n);
}

void* __cdecl appMalloc(size_t size) {
	void* pMem;
	do{
		pMem=HeapAlloc(GetProcessHeap(),HEAP_ZERO_MEMORY,size);
		if(!pMem)
		Sleep(2000);
	} while(!pMem);
	return pMem;
}

void __cdecl appFree(void* ptr) {
	HeapFree(GetProcessHeap(),0,ptr);
}

char* appBaseDir() {
	int i;
	static char svResult[MAX_PATH];
	if(!svResult[0]) {
		GetModuleFileName(GetModuleHandle(NULL),svResult,MAX_PATH);
		for(i=lstrlen(svResult)-1;i>0;--i) {
			if('\\'==svResult[i-1] || '/'==svResult[i-1])
			break;
		}
		svResult[i]=0;
	}
	return svResult;
}

BOOL CheckFileExists(char* fname, DWORD& dwFileSize) {
	WIN32_FIND_DATA FindFile;
	HANDLE handle=FindFirstFile(fname,&FindFile);
	if(INVALID_HANDLE_VALUE!=handle) {
		dwFileSize=FindFile.nFileSizeLow;
		FindClose(handle);
		return TRUE;
	}
	dwFileSize=0;
	return FALSE;
}

char* BreakString(char* Lines, char* Tok) {
	char *tok, *s;	
	char* p=Lines;
	if(!p) return NULL;
	while(*p) {
		for(s=p,tok=Tok;(*s)&&(*tok);++s,++tok) {
			if(*s!=*tok)
			break;
		}
		if(!*tok) {
			*p=0;
			return p+lstrlen(Tok);
		}
		++p;
	}
	return NULL;
}

char* LogDateTime() {
	static char svResult[257];
	char Date[128];
	char Time[128];
	GetDateFormat(LOCALE_SYSTEM_DEFAULT,0,NULL,"dd.MM.yyyy",Date,128);
	GetTimeFormat(LOCALE_SYSTEM_DEFAULT,TIME_FORCE24HOURFORMAT,NULL,"hh':'mm",Time,128);
	wsprintf(svResult,"%.100s = %.100s",Date,Time);
	return svResult;
}

void log(char* fname, char* s, BOOL bRewrite, DWORD dwNumberOfBytesToWrite) {
	char Buffer[512];
	DWORD dwCreationDistribution, dwBytesWritten;
	dwCreationDistribution=OPEN_ALWAYS;
	if(!lstrlen(fname)) {
		mb("log empty filename");
		return;
	}
	if(bRewrite)
	dwCreationDistribution=CREATE_ALWAYS;
	HANDLE hFile=CreateFile(fname,GENERIC_WRITE,0,NULL,
	dwCreationDistribution,FILE_ATTRIBUTE_NORMAL,NULL);
	if(INVALID_HANDLE_VALUE==hFile) {
		wsprintf(Buffer,"Could not create file\n\n\"%s\"\n",fname);
		mb(Buffer);
		return;
	}
	SetFilePointer(hFile,0,NULL,FILE_END);
	if(!dwNumberOfBytesToWrite) {
		dwNumberOfBytesToWrite=lstrlen(s);
		WriteFile(hFile,s,dwNumberOfBytesToWrite,&dwBytesWritten,NULL);
	} else
		WriteFile(hFile,s,dwNumberOfBytesToWrite,&dwBytesWritten,NULL);
	CloseHandle(hFile);
}

char* TcharToANSI(WCHAR* Str) {
	HGLOBAL GlobalMem;
	int Count=WideCharToMultiByte(CP_ACP,0,Str,-1,NULL,0,NULL,NULL);
	GlobalMem=GlobalAlloc(GMEM_DDESHARE | GMEM_MOVEABLE,Count+1);
	if(!GlobalMem)
	return NULL;
	char* Data=(char*)GlobalLock(GlobalMem);
	WideCharToMultiByte(CP_ACP,0,Str,-1,Data,Count,NULL,NULL);
	Data[Count]=0;
	GlobalUnlock(GlobalMem);
	return Data;
}

char* GetDataFromClipBoard(void) {
	char* Data=NULL;
	CloseClipboard();
	if(OpenClipboard(GetActiveWindow())) {
		HANDLE hClipboardData=GetClipboardData(CF_UNICODETEXT);
		if(hClipboardData) {
			WCHAR* wData=(WCHAR*)GlobalLock(hClipboardData);
			if(wData) {
				Data=TcharToANSI(wData);
				GlobalUnlock(hClipboardData);
			}
		}
		CloseClipboard();
	}
	return Data;
}

void appDebugBreak()
{
/*#ifdef _DEBUG
	return;
#endif // End _DEBUG*/
	DebugBreak();
}

BOOL appIsDebuggerPresent() {
	BOOL Result=FALSE;
	OSVERSIONINFO WinVersion;
	WinVersion.dwOSVersionInfoSize=sizeof(OSVERSIONINFO);
	if(GetVersionEx(&WinVersion) && VER_PLATFORM_WIN32_NT==WinVersion.dwPlatformId) {
		HINSTANCE KernLib=LoadLibraryEx("kernel32.dll",NULL,0);
		if(KernLib) {
			FARPROC lIsDebuggerPresent=GetProcAddress(KernLib,"IsDebuggerPresent");
			if(lIsDebuggerPresent && lIsDebuggerPresent())
			Result=1;
			FreeLibrary(KernLib);
		}
	}
	return Result;
}

int RegDeleteKeyRecurse(HKEY hKey, LPCTSTR lpSubKey, char* svKeyBuf) {
	/* Delete keys from registry */
	// Examples:
	// HKEY hKey=HKEY_CURRENT_USER;
	// LPCTSTR lpSubKey
	// char svKeyBuf[256];
	// char svSubKey[64];
	// Software\\Old-Dos\\Old-Dos IRC Client
	// g_szRegkey=TEXT("Old-Dos");
	// GAppname=TEXT("Old-Dos IRC Client");
	// wsprintf(svSubKey,TEXT("Software\\%s\\%s"),g_szRegkey,GAppname);
	// if(-1==RegDeleteKeyRecurse(hKey,svSubKey,svKeyBuf))
	// mb("Could not delete key.");
	char svSubKeyBuf[MAX_PATH+1];
	HKEY hSubKey;
	if(ERROR_SUCCESS!=RegOpenKeyEx(hKey,lpSubKey,0,KEY_ALL_ACCESS,&hSubKey))
	return -1;	
	int nCount=0;
	while(ERROR_NO_MORE_ITEMS!=RegEnumKey(hSubKey,nCount,svKeyBuf,MAX_PATH)) {
		if(RegDeleteKeyRecurse(hSubKey,svKeyBuf,svSubKeyBuf)==-1) {
			RegCloseKey(hSubKey);
			return -1;
		}
		++nCount;
	}
	RegCloseKey(hSubKey);
	RegDeleteKey(hKey,lpSubKey);
	return 0;
}

char* ConvertByte(float Bytes) {
	/* Convert file size to Bytes, KB, MB, GB or TB */
	float tb=1099511627776;
	float gb=1073741824;
	float mb=1048576;
	float kb=1024;
	static char Result[64];
	Result[0]=0;
	if(Bytes>=tb)
	sprintf(Result,"%.2f TB",(float)Bytes/tb);
	else if(Bytes>=gb && Bytes<tb)
	sprintf(Result,"%.2f GB",(float)Bytes/gb);
	else if(Bytes>=mb && Bytes<gb)
	sprintf(Result,"%.2f MB",(float)Bytes/mb);
	else if(Bytes>=kb && Bytes<mb)
	sprintf(Result,"%.2f KB",(float)Bytes/kb);
	else sprintf(Result,"%.2f Bytes",Bytes);
	return Result;
}

LRESULT CALLBACK RichEdit_WndProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam) {
	WNDPROC Wndproc=(WNDPROC)(LONG)GetWindowLong(hWnd,GWL_USERDATA);
	if(Wndproc) {
		switch(uMsg)
		{
		case WM_RBUTTONDOWN:
		PostMessage(GetParent(hWnd),RICHEDIT_WM_RBUTTONDOWN,0,0);
		break;
		case WM_NCDESTROY:
		SetWindowLong(hWnd, GWL_WNDPROC, (LONG)Wndproc);
		SetWindowLong(hWnd, GWL_USERDATA, 0);
		break;
		}
		return CallWindowProc(Wndproc, hWnd, uMsg, wParam, lParam);
	}
	return DefWindowProc(hWnd, uMsg, wParam, lParam);
}

void appSetFont(HWND hWnd, LOGFONT* plfOld) {
	HDC hDC=GetDC(hWnd);
	if(hDC) {
		HFONT Font=(HFONT)GetCurrentObject(hDC,OBJ_FONT);
		if(!plfOld->lfFaceName[0]) {			
			if(Font)
			GetObject(Font,sizeof(LOGFONT),plfOld);
		}
		CHOOSEFONT cf;
		ZeroMemory(&cf,sizeof(CHOOSEFONT));
		cf.lStructSize=sizeof(CHOOSEFONT);
		cf.hDC = hDC;
		cf.Flags = CF_SCREENFONTS | CF_INITTOLOGFONTSTRUCT;
		cf.lpLogFont = plfOld;
		cf.nFontType = SCREEN_FONTTYPE;
		cf.hwndOwner = hWnd;
		if(IDOK==ChooseFont(&cf)) {
			DeleteObject(Font);
			Font=CreateFontIndirect(plfOld);
			if(Font) {
				SendMessage(hWnd,WM_SETFONT,(WPARAM)Font,0);
				RECT rect;
				GetClientRect(hWnd,&rect);
				InvalidateRect(hWnd,&rect,TRUE);
			}
		}
		ReleaseDC(hWnd,hDC);
	}
}

COLORREF appChooseColor(HWND hWnd, COLORREF clrCurrent) {
	static COLORREF clrCustom[16];
	static COLORREF clrResult=clrCurrent;
	CHOOSECOLOR cc;
	ZeroMemory(&cc,sizeof(CHOOSECOLOR));
	cc.lStructSize=sizeof(CHOOSECOLOR);
	cc.Flags=CC_RGBINIT | CC_FULLOPEN;
	cc.rgbResult=clrCurrent;
	cc.hwndOwner=hWnd;
	cc.lpCustColors=(LPDWORD)clrCustom;
	cc.lpTemplateName=NULL;
	if(ChooseColor(&cc))
	clrResult=cc.rgbResult;
	InvalidateRect(hWnd,NULL,TRUE);
	return clrResult;
}

HBRUSH appCreateColor(COLORREF clrCurrent) {
	LOGBRUSH lplb;
	lplb.lbStyle=BS_SOLID;
	lplb.lbColor=clrCurrent;
	lplb.lbHatch=HS_BDIAGONAL;
	HBRUSH Brush=CreateBrushIndirect(&lplb);
	if(!Brush)
	Brush=reinterpret_cast<HBRUSH>(COLOR_WINDOW+1);
 	return Brush;
}

void MDI_OnPaint(HWND hWnd) {
	HBITMAP hBitmap=NULL;
	if(!theApp.m_nRuncount) {
		if(g_strImgFile.IsEmpty()) {
			/* Load from resource. */
			hBitmap=LoadBitmap(g_hInstance,MAKEINTRESOURCE(IDB_VACA));
		}
	}
	if(g_bImage) {
		hBitmap=(HBITMAP)LoadImage(NULL,g_strImgFile,IMAGE_BITMAP,0,0,LR_LOADFROMFILE | LR_CREATEDIBSECTION);
		if(!hBitmap)
		g_bImage=FALSE;
	}
	InvalidateRect(hWnd,NULL,TRUE);
	PAINTSTRUCT ps;
	HDC hDC=BeginPaint(hWnd,&ps);
	RECT rect;
	GetClientRect(hWnd,&rect);
	/* Fill solid color. */
	FillRect(hDC,&rect,CreateSolidBrush(g_dwSolidColor));
	if(hBitmap) {
		HDC hDCMem=CreateCompatibleDC(hDC);
		SelectObject(hDCMem,hBitmap);
		BITMAP bmp;
		GetObject(hBitmap,sizeof(BITMAP),&bmp);
		/* Picture size to window
		StretchBlt(hDC,0,0,rect.right-rect.left,
		rect.bottom-rect.top,hDCMem,
		0,0,bmp.bmWidth,bmp.bmHeight,SRCCOPY);*/
		int x, y;
		if(g_bTile) {
			/* Picture multiple. */
			for(y=0; y<(rect.bottom-rect.top); y+=bmp.bmHeight) {
				for(x=0; x<(rect.right-rect.left); x+=bmp.bmWidth) {
					BitBlt(hDC,
					x,y,bmp.bmWidth,bmp.bmHeight,hDCMem,0,0,SRCCOPY);
				}
			}
		} else {
			/* Picture to center window. */
			BitBlt(hDC,((rect.right-rect.left)/2)-(bmp.bmWidth/2),
			((rect.bottom-rect.top)/2)-(bmp.bmHeight/2),
			bmp.bmWidth,bmp.bmHeight,hDCMem,0,0,SRCCOPY);
		} /* End "if g_bTile" */
		DeleteDC(hDCMem);
	}
	EndPaint(hWnd,&ps);
}

void MDI_OnRButtonDown(HWND hWnd) {
	HMENU hmenu=LoadMenu(AfxGetInstanceHandle(),MAKEINTRESOURCE(IDR_BKGNDPOPUP));
	HMENU hsubmenu=GetSubMenu(hmenu,0);
	CheckMenuItem(hsubmenu,IDM_BITMAP,g_bImage?MF_CHECKED:MF_UNCHECKED);
	CheckMenuItem(hsubmenu,IDM_TILE,g_bTile?MF_CHECKED:MF_UNCHECKED);
	if(g_bLogEnable) {
		DWORD dwFileSize;
		if(CheckFileExists((char*)theApp.m_sLogFilename.operator LPCTSTR(),dwFileSize)) {
			InsertMenu(hsubmenu,-1,MF_SEPARATOR,-1,NULL);
			InsertMenu(hsubmenu,-1,MF_BYPOSITION,IDM_SHOW_LOG,"Show Log");
		}
	} /* End "if(g_bLogEnable)" */
	POINT pt;
	GetCursorPos(&pt);
	SetForegroundWindow(hWnd);
	int cmd=TrackPopupMenu(hsubmenu,TPM_RETURNCMD|TPM_RIGHTBUTTON,pt.x,pt.y,0,hWnd,NULL);
	switch(cmd) {
	case IDM_TILE:
	g_bTile=!g_bTile;
	break;
	case IDM_SOLIDCOLOR: {
		CColorDialog ccd;
		if(IDOK==ccd.DoModal())
		g_dwSolidColor=ccd.GetColor();
		}
		break;
	case IDM_BITMAP: {
		g_bImage=!g_bImage;
			if(g_bImage) {
				CFileDialog cfd(TRUE,".bmp",g_strImgFile,OFN_PATHMUSTEXIST|OFN_NOCHANGEDIR|OFN_HIDEREADONLY,"Bitmap Files (*.bmp)|*.bmp||");
				if(IDOK==cfd.DoModal())
				g_strImgFile=cfd.GetPathName();
				else
				g_bImage=FALSE;
			}
		} /* End "case IDM_BITMAP" */
		break;
	case IDM_SHOW_LOG: {
		HINSTANCE ShellExError=ShellExecute(NULL,"open",theApp.m_sLogFilename,NULL,NULL,SW_SHOWNORMAL);
		if(INT_PTR(ShellExError)<=32) {
			char svBuff[256];
			wsprintf(svBuff,"Cannot open\n\n\"%s\"",theApp.m_sLogFilename);
			mb(svBuff);
			}
		} /* End "case IDM_SHOW_LOG" */
	} /* End "switch(cmd)" */
	DestroyMenu(hmenu);
	InvalidateRect(hWnd,NULL,TRUE);
}

LRESULT CALLBACK MDI_WndProc(HWND hWnd, UINT uMsg, WPARAM wParam, LPARAM lParam) {
	WNDPROC Wndproc=(WNDPROC)(LONG)GetWindowLong(hWnd,GWL_USERDATA);
	if(Wndproc) {
		switch(uMsg) {
		case WM_PAINT:
		MDI_OnPaint(hWnd);
		break;
		case WM_RBUTTONDOWN:
		MDI_OnRButtonDown(hWnd);
		break;
		case WM_NCDESTROY:
		SetWindowLong(hWnd,GWL_WNDPROC,(LONG)Wndproc);
		SetWindowLong(hWnd,GWL_USERDATA,0);
		break;
		}
		return CallWindowProc(Wndproc,hWnd,uMsg,wParam,lParam);
	}
	return DefWindowProc(hWnd,uMsg,wParam,lParam);
}
