// MainFrm.cpp

#include "stdafx.h"
#include "App.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

IMPLEMENT_DYNAMIC(CMainFrame, CMDIFrameWnd)

BEGIN_MESSAGE_MAP(CMainFrame, CMDIFrameWnd)
	//{{AFX_MSG_MAP(CMainFrame)
	ON_WM_CREATE()
	ON_WM_GETMINMAXINFO()
	ON_WM_SIZE()
	ON_WM_MOVE()
	ON_WM_TIMER()
	ON_WM_DESTROY()
	ON_WM_INITMENUPOPUP()
	//}}AFX_MSG_MAP
	ON_MESSAGE(WM_LOGUPDATE, OnLogUpdate)
END_MESSAGE_MAP()

static UINT indicators[] =
{
	ID_SEPARATOR,           // status line indicator
	ID_INDICATOR_CAPS,
	ID_INDICATOR_NUM,
	ID_INDICATOR_SCRL,
};

/////////////////////////////////////////////////////////////////////////////
// CMainFrame construction/destruction

CMainFrame::CMainFrame()
{
	// TODO: add member initialization code here
}

CMainFrame::~CMainFrame()
{
}

void CMainFrame::OnDestroy() {
	CFrameWnd::OnDestroy();
	if(m_nTimer) {
		KillTimer(m_nTimer);
		m_nTimer=NULL;
	}
	DWORD dwFileSize;
	if(CheckFileExists((char*)theApp.m_sLogFilename.operator LPCTSTR(),dwFileSize)) {
		char svBuff[64];
		wsprintf(svBuff,"Log file close, %s\r\n",LogDateTime());
		log((char*)theApp.m_sLogFilename.operator LPCTSTR(),svBuff);
	}
}

int CMainFrame::OnCreate(LPCREATESTRUCT lpCreateStruct) {
	if (CMDIFrameWnd::OnCreate(lpCreateStruct) == -1)
		return -1;
	if (!m_wndToolBar.CreateEx(this, TBSTYLE_FLAT, WS_CHILD | WS_VISIBLE | CBRS_TOP
		| CBRS_GRIPPER | CBRS_TOOLTIPS | CBRS_FLYBY | CBRS_SIZE_DYNAMIC) ||
		!m_wndToolBar.LoadToolBar(IDR_MAINFRAME)) {
		TRACE0("Failed to create toolbar\n");
		return -1;      // fail to create
	}
	if (!m_wndStatusBar.Create(this) ||
		!m_wndStatusBar.SetIndicators(indicators,
		  sizeof(indicators)/sizeof(UINT))) {
		TRACE0("Failed to create status bar\n");
		return -1;      // fail to create
	}
	// TODO: Delete these three lines if you don't want the toolbar to
	// be dockable
	m_wndToolBar.EnableDocking(CBRS_ALIGN_ANY);
	EnableDocking(CBRS_ALIGN_ANY);
	DockControlBar(&m_wndToolBar);
	if(m_hWndMDIClient) {
		/* Set subroutine MDI_WndProc */
		DWORD dwStyle=GetWindowLong(m_hWndMDIClient,GWL_WNDPROC);
		SetWindowLong(m_hWndMDIClient,GWL_USERDATA,dwStyle);
		SetWindowLong(m_hWndMDIClient,GWL_WNDPROC,(LONG)MDI_WndProc);
	}

#ifndef _DEBUG
	CSplash spl;
	spl.DoModal();
#endif /* End _DEBUG */
	m_nTimer=SetTimer(TIMER_MAIN,TIMER_MAIN_DELAY,0);
	if(!m_nTimer) {
		AfxGetApp()->m_pMainWnd->ShowWindow(SW_HIDE);
		mb("Failed SetTimer");
	}
	return 0;
}

BOOL CMainFrame::PreCreateWindow(CREATESTRUCT& cs) {
	WNDCLASS wndcls;
	BOOL Result=CMDIFrameWnd::PreCreateWindow(cs);
	if(!GetClassInfo(g_hInstance,theApp.m_sWndname,&wndcls)) {
		GetClassInfo(g_hInstance,cs.lpszClass,&wndcls);
		wndcls.style &=~WS_EX_CLIENTEDGE;
		wndcls.lpszClassName=theApp.m_sWndname;
		wndcls.hIcon=::LoadIcon(g_hInstance,MAKEINTRESOURCE(IDR_MAINFRAME));
		ASSERT(NULL!=wndcls.hIcon);		
		if(!AfxRegisterClass(&wndcls))
		AfxThrowResourceException();
	}
	cs.lpszClass=theApp.m_sWndname;
	CDisplayIC dc;
	CRect rectDisplay(0,0,dc.GetDeviceCaps(HORZRES),dc.GetDeviceCaps(VERTRES));
	CRect rect=theApp.m_rectFrame;
	if(rect.Width() > 0 && rect.Height() > 0) {
		if(rectDisplay.PtInRect(rect.TopLeft()) && rectDisplay.PtInRect(rect.BottomRight())) {
			cs.x=rect.left;
			cs.y=rect.top;
			cs.cx=rect.Width();
			cs.cy=rect.Height();
		}
	} else {
		int nWidth=WINDOW_WIDTH;
		int nHeight=WINDOW_HEIGHT;		
		int nTemp=rectDisplay.Width();
		if(nWidth>nTemp) {
			nWidth=WINDOW_WIDTH;
			nHeight=WINDOW_HEIGHT;
		}
		cs.cx=nWidth;
		cs.cy=nHeight;
		cs.x=(rectDisplay.Width()-cs.cx)/2;
		cs.y=(rectDisplay.Height()-cs.cy)/2;
	}
#ifndef _DEBUG
	if(appIsDebuggerPresent())
	appDebugBreak();
#endif /* End _DEBUG */
	return Result;
}

/////////////////////////////////////////////////////////////////////////////
// CMainFrame diagnostics

#ifdef _DEBUG
void CMainFrame::AssertValid() const
{
	CMDIFrameWnd::AssertValid();
}

void CMainFrame::Dump(CDumpContext& dc) const
{
	CMDIFrameWnd::Dump(dc);
}

#endif //_DEBUG

void CMainFrame::OnMove(int x, int y) {
	CMDIFrameWnd::OnMove(x,y);
	WINDOWPLACEMENT wp;
	wp.length=sizeof(wp);
	GetWindowPlacement(&wp);
	theApp.m_rectFrame=wp.rcNormalPosition;
	CView* pView=GetActiveView();
	if(pView)
	pView->SendMessage(WM_MOVE);
}

void CMainFrame::OnSize(UINT nType, int cx, int cy) {
	CMDIFrameWnd::OnSize(nType, cx, cy);
	theApp.m_bShowFrame=(SIZE_MAXIMIZED==nType);
	if(SIZE_RESTORED==nType)
	GetWindowRect(theApp.m_rectFrame);
}

void CMainFrame::OnGetMinMaxInfo(MINMAXINFO FAR* lpMMI) {
	lpMMI->ptMinTrackSize.x=MIN_WINDOW_WIDTH;
	lpMMI->ptMinTrackSize.y=MIN_WINDOW_HEIGHT;
}

void CMainFrame::OnTimer(UINT nIDEvent) {
	if(nIDEvent==TIMER_MAIN) {
		// www.tenouk.com/visualcplusmfc/visualcplusmfc8a.html
		// www.programmersought.com/article/13814261364/
		//CMainFrame* pFrame = (CMainFrame*) AfxGetApp()->m_pMainWnd;
		//CStatusBar* pStatus = &pFrame->m_wndStatusBar;
		//pStatus->GetStatusBarCtrl().SetBkColor(RGB(180,180,180));
		CString s;
		if(g_bLogEnable) {
			DWORD dwFileSize;
			if(CheckFileExists((char*)theApp.m_sLogFilename.operator LPCTSTR(),dwFileSize)) {
				char* p=ConvertByte((float)dwFileSize);
				s.Format("Log file (size %s)",p);
				m_wndStatusBar.SetPaneText(0,s);
			} /* End "CheckFileExists" */
			else
			m_wndStatusBar.SetPaneText(0,"Ready");
		} /* End "if(g_bLogEnable)" */
		else {
			m_wndStatusBar.GetPaneText(0,s);
			int n=s.Find("og ");
			if(-1L!=n)
				m_wndStatusBar.SetPaneText(0,"");
		}
	} /* End "if(nIDEvent==TIMER_MAIN)" */
}

LRESULT CMainFrame::OnLogUpdate(WPARAM, LPARAM) {
	// www.tenouk.com/visualcplusmfc/visualcplusmfc8a.html
	// www.programmersought.com/article/13814261364/
	//CMainFrame* pFrame = (CMainFrame*) AfxGetApp()->m_pMainWnd;
	//CStatusBar* pStatus = &pFrame->m_wndStatusBar;
	//pStatus->GetStatusBarCtrl().SetBkColor(RGB(180,180,180));
	CString s;
	if(g_bLogEnable) {
		DWORD dwFileSize;
		if(CheckFileExists((char*)theApp.m_sLogFilename.operator LPCTSTR(),dwFileSize)) {
			char* p=ConvertByte((float)dwFileSize);
			s.Format("Log file (size %s)",p);
			m_wndStatusBar.SetPaneText(0,s);
		} /* End "CheckFileExists" */
		else
		m_wndStatusBar.SetPaneText(0,"Ready");
	} /* End "if(g_bLogEnable)" */
	else {
			m_wndStatusBar.GetPaneText(0,s);
			int n=s.Find("og ");
			if(-1L!=n)
				m_wndStatusBar.SetPaneText(0,"Ready");
	}
	return 0;
}

void CMainFrame::RecalcLayout(BOOL bNotify) {
	/* Resize child www.rsdn.org/article/qna/mfc/mdisize.xml */
	CMDIFrameWnd::RecalcLayout(bNotify);
	CRect r;
	GetDlgItem(AFX_IDW_PANE_FIRST)->GetClientRect(r);
	if(r != m_MDIRect) {
		m_MDIRect=r;
		POSITION ptemp=AfxGetApp()->GetFirstDocTemplatePosition();
		while(ptemp) {
			CDocTemplate* temp=AfxGetApp()->GetNextDocTemplate(ptemp);
			POSITION pdoc=temp->GetFirstDocPosition();
			while(pdoc) {
				CDocument* doc=temp->GetNextDoc(pdoc);
				POSITION pview=doc->GetFirstViewPosition();
				while(pview) {
					CFrameWnd* frame=doc->GetNextView(pview)->GetParentFrame();
					if(frame)
						frame->PostMessage(WM_COMMAND,IDM_RECALC_SIZE);
				}
			}
		}
	}
}

CBitmap* CMainFrame::ConvertIconToBitmap(HICON hIcon) {
	const int cx=GetSystemMetrics(SM_CXSMICON);
	const int cy=GetSystemMetrics(SM_CYSMICON);
	CDC dc;
	CBitmap bmp;
	CClientDC bmpDC(this);
	dc.CreateCompatibleDC(&bmpDC);
	bmp.CreateCompatibleBitmap(&bmpDC,cx,cy);
	CBitmap* pOldBmp=(CBitmap*)dc.SelectObject(&bmp);
	::DrawIconEx(dc.GetSafeHdc(),0,0,hIcon,cx,cy,0,(HBRUSH)GetSysColor(COLOR_MENU),DI_NORMAL);
	dc.SelectObject(pOldBmp);
	dc.DeleteDC();
	HBITMAP hBitmap=(HBITMAP)::CopyImage((HANDLE)((HBITMAP)bmp),IMAGE_BITMAP,0,0,LR_DEFAULTSIZE);
	if(hBitmap)
		return CBitmap::FromHandle(hBitmap);
	return NULL;
}

void CMainFrame::OnInitMenuPopup(CMenu* pPopupMenu, UINT nIndex, BOOL bSysMenu) {
	CFrameWnd::OnInitMenuPopup(pPopupMenu, nIndex, bSysMenu);
	HICON hIcon=AfxGetApp()->LoadIcon(IDI_SPICH);
	pPopupMenu->SetMenuItemBitmaps(ID_FILE_OPEN,MF_BYCOMMAND,ConvertIconToBitmap(hIcon),NULL);
	BOOL bPlaySound=AfxGetApp()->GetProfileInt("Settings","PlaySound",FALSE);
	if(bPlaySound)
	hIcon=AfxGetApp()->LoadIcon(IDI_SOUND);
	else
	hIcon=AfxGetApp()->LoadIcon(IDI_SOUND_OFF);
	pPopupMenu->SetMenuItemBitmaps(ID_OPT_SOUND,MF_BYCOMMAND,ConvertIconToBitmap(hIcon),NULL);
	hIcon=AfxGetApp()->LoadIcon(IDI_ABOUT);
	pPopupMenu->SetMenuItemBitmaps(ID_APP_ABOUT,MF_BYCOMMAND,ConvertIconToBitmap(hIcon),NULL);
}
