////////////////////////////////////////////////////////////////////////////////
// PlayDX.cpp

#include "stdafx.h"
#include "App.h"
#define DIRECTX /* Use DirectX */
#ifdef DIRECTX
#include <mmsystem.h>
#include <dsound.h>
#else
#include <vfw.h>
#endif /* End DIRECTX */

#ifdef DIRECTX
BOOL PlayWavEx(char* svFilename) {
	if(!lstrlen(svFilename))
	return FALSE;
	DWORD dwSize;
	if(!CheckFileExists(svFilename,dwSize))
	return FALSE;
	HANDLE hFile=CreateFile(svFilename,GENERIC_READ,
	FILE_SHARE_READ,NULL,OPEN_EXISTING,FILE_ATTRIBUTE_NORMAL,NULL);
	if(INVALID_HANDLE_VALUE==hFile)
	return FALSE;
	LPDIRECTSOUND pDirectSound;
	if(FAILED(DirectSoundCreate(NULL,&pDirectSound,NULL))) {
		CloseHandle(hFile);
		return FALSE;
	}
	HWND hWnd=GetForegroundWindow();
	if(FAILED(pDirectSound->SetCooperativeLevel(hWnd,DSSCL_NORMAL))) {
		CloseHandle(hFile);
		return FALSE;
	}
	LONG lDistanceToMove=0;
	SetFilePointer(hFile,lDistanceToMove,NULL,FILE_BEGIN);
	DWORD dwChunk, dwBytesRead;
	ReadFile(hFile,&dwChunk,sizeof(DWORD),&dwBytesRead,NULL);
	if(dwChunk!=MAKEFOURCC('R','I','F','F')) {
		CloseHandle(hFile);
		return FALSE;
	}
	lDistanceToMove+=(dwBytesRead+4);
	SetFilePointer(hFile,lDistanceToMove,NULL,FILE_BEGIN);
	ReadFile(hFile,&dwChunk,sizeof(DWORD),&dwBytesRead,NULL);
	if(dwChunk!=MAKEFOURCC('W','A','V','E')) {
		CloseHandle(hFile);
		return FALSE;
	}
	lDistanceToMove+=dwBytesRead;
	SetFilePointer(hFile,lDistanceToMove,NULL,FILE_BEGIN);
	ReadFile(hFile,&dwChunk,sizeof(DWORD),&dwBytesRead,NULL);
	if(dwChunk!=MAKEFOURCC('f','m','t',' ')) {
		CloseHandle(hFile);
		return FALSE;
	}
	lDistanceToMove+=dwBytesRead;
	SetFilePointer(hFile,lDistanceToMove,NULL,FILE_BEGIN);
	ReadFile(hFile,&dwChunk,sizeof(DWORD),&dwBytesRead,NULL);
	if(!dwChunk) {
		CloseHandle(hFile);
		return FALSE;
	}
	lDistanceToMove+=dwBytesRead;
	WAVEFORMATEX wfx=WAVEFORMATEX();
	SetFilePointer(hFile,lDistanceToMove,NULL,FILE_BEGIN);
	ReadFile(hFile,&wfx,16,&dwBytesRead,NULL);
	if(1!=wfx.wFormatTag) {
		CloseHandle(hFile);
		return FALSE;
	}
	lDistanceToMove+=dwBytesRead;
	SetFilePointer(hFile,lDistanceToMove,NULL,FILE_BEGIN);
	ReadFile(hFile,&dwChunk,sizeof(DWORD),&dwBytesRead,NULL);
	if(dwChunk==MAKEFOURCC('f','a','c','t')) {
		DWORD dwSizeFact=0;
		lDistanceToMove+=4;
		SetFilePointer(hFile,lDistanceToMove,NULL,FILE_BEGIN);
		ReadFile(hFile,&dwSizeFact,sizeof(DWORD),&dwBytesRead,NULL);
		lDistanceToMove+=4;
		SetFilePointer(hFile,lDistanceToMove,NULL,FILE_BEGIN);
		ReadFile(hFile,&dwChunk,sizeof(DWORD),&dwBytesRead,NULL);
	}
	if(dwChunk!=MAKEFOURCC('d','a','t','a')) {
		CloseHandle(hFile);
		return FALSE;
	}
	lDistanceToMove+=4;
	SetFilePointer(hFile,lDistanceToMove,NULL,FILE_BEGIN);
	ReadFile(hFile,&dwSize,sizeof(DWORD),&dwBytesRead,NULL);
	char* pData=new char[dwSize];
	lDistanceToMove+=4;
	SetFilePointer(hFile,lDistanceToMove,NULL,FILE_BEGIN);
	ReadFile(hFile,pData,dwSize,&dwBytesRead,NULL);
	CloseHandle(hFile);
	LPDIRECTSOUNDBUFFER pSoundBuffer=NULL;
	DSBUFFERDESC dsbd;
	ZeroMemory(&dsbd,sizeof(dsbd));
	dsbd.dwSize=sizeof(DSBUFFERDESC);
	dsbd.dwBufferBytes=dwSize;
	dsbd.dwFlags=DSBCAPS_STATIC;
	dsbd.dwSize=sizeof(DSBUFFERDESC);
	dsbd.lpwfxFormat=&wfx;
	pDirectSound->CreateSoundBuffer(&dsbd,&pSoundBuffer,0);
	void* pDst=0;
	dwSize=0;
	pSoundBuffer->Lock(0,0,&pDst,&dwSize,0,0,DSBLOCK_ENTIREBUFFER);
	memcpy(pDst,pData,dwSize);
	pSoundBuffer->Unlock(pDst,dwSize,0,0);
	pSoundBuffer->Play(0,0,0);
	DWORD Status=0;
	do {
		pSoundBuffer->GetStatus(&Status);
	} while(Status==DSBSTATUS_PLAYING);
	pDirectSound->Release();
	return TRUE;
}
#endif /* End DIRECTX */

DWORD WINAPI SoundThreadEntry(LPVOID parm) {
	char* svFilename=reinterpret_cast<char*>(parm);
#ifdef DIRECTX
	PlayWavEx(svFilename);
#else
	if(!PlaySound(svFilename,NULL,SND_FILENAME|SND_NODEFAULT|SND_NOWAIT|SND_ASYNC))
		mb("Unable to play sound.");
#endif /* End DIRECTX */
	return 0;
}

void Beep(char* svFilename) {
	DWORD dwFileSize;
	if(CheckFileExists(svFilename,dwFileSize)) {
		DWORD tid;
		LPVOID lpParameter=reinterpret_cast<LPVOID>(svFilename);
		HANDLE hThread=CreateThread(NULL,0,SoundThreadEntry,lpParameter,0,&tid);
		if(hThread)
		CloseHandle(hThread);
		else
		mb("Could not create thread.\nYour system may be misbehaving.");
	}
}

////////////////////////////////////////////////////////////////////////////////
// <<eof>> PlayDX.cpp
////////////////////////////////////////////////////////////////////////////////
