// SoundDlg.cpp

#include "stdafx.h"
#include "App.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

char g_pszSound[512];

CSoundDlg::CSoundDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CSoundDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CSoundDlg)
	m_sFilename=AfxGetApp()->GetProfileString("Settings","Sound File",NULL);
	m_bPlaySound=AfxGetApp()->GetProfileInt("Settings","PlaySound",FALSE);
	//}}AFX_DATA_INIT
}

void CSoundDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CSoundDlg)
	DDX_Control(pDX, IDC_ED_FILENAME_WAV, m_edit);
	DDX_Text(pDX, IDC_ED_FILENAME_WAV, m_sFilename);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CSoundDlg, CDialog)
	//{{AFX_MSG_MAP(CSoundDlg)
	ON_EN_CHANGE(IDC_ED_FILENAME_WAV, OnChange)
#if _MSC_VER == 1200			// MSVC++ 6.0
	ON_BN_CLICKED(IDC_BT_BROWSE_WAV, OnBrowse)
	ON_BN_CLICKED(IDC_BT_TEST_SOUND, OnTestSound)
#else
	ON_BN_CLICKED(IDC_BT_BROWSE_WAV, &CSoundDlg::OnBrowse)
#endif
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CSoundDlg message handlers

void CSoundDlg::OnOK() {
	GetDlgItemText(IDC_ED_FILENAME_WAV,m_sFilename);
	DWORD dwFileSize;
	if(!CheckFileExists((char*)m_sFilename.operator LPCTSTR(),dwFileSize)) {
		CString s;
		s.Format("Missing file \"%s\"",m_sFilename);
		MessageBox(s,"Error",MB_ICONWARNING|MB_OK|MB_TOPMOST|MB_SETFOREGROUND);
		return;
	}
	if(BST_CHECKED==SendDlgItemMessage(IDC_CHECK_PLAY_SOUND,BM_GETCHECK,0,0))
	m_bPlaySound=TRUE;
	else
	m_bPlaySound=FALSE;
	AfxGetApp()->WriteProfileString("Settings","Sound File",m_sFilename);
	AfxGetApp()->WriteProfileInt("Settings","PlaySound",m_bPlaySound);
	CDialog::OnOK();
}

void CSoundDlg::OnChange() {
	UpdateButtons();
}

void CSoundDlg::UpdateButtons() {
	GetDlgItem(IDC_CHECK_PLAY_SOUND)->EnableWindow(GetDlgItem(IDC_ED_FILENAME_WAV)->GetWindowTextLength()>0);
	GetDlgItem(IDOK)->EnableWindow(GetDlgItem(IDC_ED_FILENAME_WAV)->GetWindowTextLength()>0);
	GetDlgItem(IDC_BT_TEST_SOUND)->EnableWindow(GetDlgItem(IDC_ED_FILENAME_WAV)->GetWindowTextLength()>0);
}

BOOL CSoundDlg::OnInitDialog() {
	CDialog::OnInitDialog();
	HICON Icon=LoadIcon(g_hInstance,MAKEINTRESOURCE(IDI_SOUND));
	if(Icon) SendMessage(WM_SETICON,ICON_BIG,(LPARAM)Icon);
	DWORD dwFileSize;
	if(!theApp.m_nRuncount) {
		m_sFilename.Format("%sTalk.wav",appBaseDir());
		if(!CheckFileExists((char*)m_sFilename.operator LPCTSTR(),dwFileSize))
			m_sFilename.Empty();
	} else {
		if(!CheckFileExists((char*)m_sFilename.operator LPCTSTR(),dwFileSize))
			m_sFilename.Empty();
	}
	if(m_sFilename.IsEmpty())
		m_bPlaySound=FALSE;
	m_edit.SetWindowText(m_sFilename);
	CheckDlgButton(IDC_CHECK_PLAY_SOUND,m_bPlaySound ? BST_CHECKED:BST_UNCHECKED);
	UpdateButtons();
	return TRUE;
}

void CSoundDlg::OnTestSound() {
	GetDlgItemText(IDC_ED_FILENAME_WAV,m_sFilename);
	DWORD dwFileSize;
	if(!CheckFileExists((char*)m_sFilename.operator LPCTSTR(),dwFileSize)) {
		CString s;
		s.Format("Missing file \"%s\"",m_sFilename);
		MessageBox(s,"Error",MB_ICONWARNING|MB_OK|MB_TOPMOST|MB_SETFOREGROUND);
		return;
	}
	if(!m_sFilename.IsEmpty()) {
		Beep((char*)m_sFilename.operator LPCTSTR());
		/*if(!PlaySound(m_sFilename,NULL,SND_FILENAME|SND_NODEFAULT|SND_NOWAIT|SND_ASYNC))
			mb("Unable to play sound.");*/
	}
}

BOOL TemplateNotify(HWND hWnd, LPOFNOTIFY pofn) {
	/* Processes the WM_NOTIFY message
	notifications that is sent to the hook dialog
	procedure for the File Open common dialog. */
	char svFilepath[MAX_PATH];
	switch(pofn->hdr.code) {
		/* The selection has changed. */
		case CDN_SELCHANGE: {
			//CommDlg_OpenSave_GetSpec(GetParent(hWnd),svFilename,sizeof(svFilename));
			CommDlg_OpenSave_GetFilePath(GetParent(hWnd),svFilepath,sizeof(svFilepath));
			wsprintf(g_pszSound,"%s",svFilepath);
		}
		break;
		case CDN_FOLDERCHANGE: /* A new folder has been opened. */
		CommDlg_OpenSave_GetFolderPath(GetParent(hWnd),svFilepath,sizeof(svFilepath));
		break;
		case CDN_FILEOK: /* The 'OK' pushbutton has been pressed. */
			SetWindowLong(hWnd,DWL_MSGRESULT,1L);
			break;
		case CDN_SHAREVIOLATION: /* Received a sharing violation. */
			mb("Got a sharing violation notify.");
			break;
	} /* End "switch(pofn->hdr.code)" */
	return TRUE;
}

BOOL CALLBACK DlgProcTemplate(HWND hDlg, UINT uMsg, WPARAM wParam, LPARAM lParam) {
	switch(uMsg) {
	case WM_INITDIALOG:
		/* Save off the long pointer to the OPENFILENAME structure. */
		SetWindowLong(hDlg,DWL_USER,lParam);
		break;

	case WM_COMMAND: {
		int nID=LOWORD(wParam);
		switch(nID) {
		case IDC_BT_TEST_PLAY: {
			if(g_pszSound[0]) {
				Beep(g_pszSound);
				/*if(!PlaySound(g_pszSound,NULL,SND_FILENAME|SND_NODEFAULT|SND_NOWAIT|SND_ASYNC))
					mb("Unable to play sound.");*/
				}/* End "if(g_pszSound[0])" */
			} /* End "case IDC_BT_TEST_PLAY" */
			break;
		} /* End "switch(nID)" */
	} /* End "case WM_COMMAND" */
	break;
	case WM_DESTROY: {
		LPOPENFILENAME lpOFN=(LPOPENFILENAME)GetWindowLong(hDlg,DWL_USER);
		} /* End "case WM_DESTROY" */
		break;
	case WM_NOTIFY:
		TemplateNotify(hDlg,(LPOFNOTIFY)lParam);
	default:
		return FALSE;
	} /* End "switch(uMsg)" */
	return TRUE;
}

void CSoundDlg::OnBrowse() {
	char svFilename[MAX_PATH];
	svFilename[0]=0;
	OPENFILENAME ofn;
	ofn.lStructSize=sizeof(OPENFILENAME);
	ofn.hwndOwner=GetSafeHwnd();
	ofn.hInstance=g_hInstance;
	ofn.lpstrFilter="Sound Files (*.wav)\0*.wav\0";
	ofn.lpstrCustomFilter=NULL;
	ofn.nMaxCustFilter=0;
	ofn.nFilterIndex=0;
	ofn.lpstrFile=svFilename;
	ofn.nMaxFile=sizeof(svFilename);
	ofn.lpstrFileTitle=NULL;
	ofn.nMaxFileTitle=0;
	ofn.lpstrInitialDir=NULL;
	ofn.lpstrTitle="Open a sound file";
	ofn.nFileOffset=0;
	ofn.nFileExtension=0;
	ofn.lpstrDefExt=NULL;
	ofn.lCustData=NULL;
	ofn.lpfnHook=(LPOFNHOOKPROC)DlgProcTemplate;
	ofn.lpTemplateName=MAKEINTRESOURCE(IDD_TEMPLATE);
	ofn.Flags=OFN_PATHMUSTEXIST|OFN_HIDEREADONLY|OFN_EXPLORER|OFN_ENABLEHOOK|OFN_ENABLETEMPLATE;
	if(GetOpenFileName(&ofn)) {
		m_sFilename=CString(svFilename);
		m_edit.SetWindowText(m_sFilename);
	}
}
